/**
 */
package tools.descartes.dni.dnimm3ap;

import org.eclipse.emf.ecore.EAttribute;
import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EPackage;
import org.eclipse.emf.ecore.EReference;

import tools.descartes.dni.dnimm3.DNIPackage;

/**
 * <!-- begin-user-doc -->
 * The <b>Package</b> for the model.
 * It contains accessors for the meta objects to represent
 * <ul>
 *   <li>each class,</li>
 *   <li>each feature of each class,</li>
 *   <li>each operation of each class,</li>
 *   <li>each enum,</li>
 *   <li>and each data type</li>
 * </ul>
 * <!-- end-user-doc -->
 * @see tools.descartes.dni.dnimm3ap.DNIAPFactory
 * @model kind="package"
 *        annotation="http://www.eclipse.org/emf/2002/GenModel modelDirectory='/tools.descartes.dni.adaptation/src' editDirectory='/tools.descartes.dni.adaptation/src' editorDirectory='/tools.descartes.dni.adaptation/src' fileExtensions='dniap' prefix='DNIAP' suppressEMFTypes='true' basePackage='tools.descartes.dni'"
 * @generated
 */
public interface DNIAPPackage extends EPackage {
	/**
	 * The package name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNAME = "dnimm3ap";

	/**
	 * The package namespace URI.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_URI = "http://descartes.tools/dni-adaptation-metamodel-3.1";

	/**
	 * The package namespace name.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	String eNS_PREFIX = "dnimm3ap";

	/**
	 * The singleton instance of the package.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	DNIAPPackage eINSTANCE = tools.descartes.dni.dnimm3ap.impl.DNIAPPackageImpl.init();

	/**
	 * The meta object id for the '{@link tools.descartes.dni.dnimm3ap.impl.AdaptationPointsImpl <em>Adaptation Points</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dni.dnimm3ap.impl.AdaptationPointsImpl
	 * @see tools.descartes.dni.dnimm3ap.impl.DNIAPPackageImpl#getAdaptationPoints()
	 * @generated
	 */
	int ADAPTATION_POINTS = 0;

	/**
	 * The feature id for the '<em><b>Repositories</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTATION_POINTS__REPOSITORIES = 0;

	/**
	 * The feature id for the '<em><b>Groups</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTATION_POINTS__GROUPS = 1;

	/**
	 * The feature id for the '<em><b>Network Infrastructure</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTATION_POINTS__NETWORK_INFRASTRUCTURE = 2;

	/**
	 * The number of structural features of the '<em>Adaptation Points</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTATION_POINTS_FEATURE_COUNT = 3;

	/**
	 * The number of operations of the '<em>Adaptation Points</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTATION_POINTS_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dni.dnimm3ap.impl.AdaptationRepositoryImpl <em>Adaptation Repository</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dni.dnimm3ap.impl.AdaptationRepositoryImpl
	 * @see tools.descartes.dni.dnimm3ap.impl.DNIAPPackageImpl#getAdaptationRepository()
	 * @generated
	 */
	int ADAPTATION_REPOSITORY = 1;

	/**
	 * The feature id for the '<em><b>Nodes</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTATION_REPOSITORY__NODES = 0;

	/**
	 * The feature id for the '<em><b>End Performances</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTATION_REPOSITORY__END_PERFORMANCES = 1;

	/**
	 * The feature id for the '<em><b>Intermediate Performances</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTATION_REPOSITORY__INTERMEDIATE_PERFORMANCES = 2;

	/**
	 * The feature id for the '<em><b>Sdn Node Performances</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTATION_REPOSITORY__SDN_NODE_PERFORMANCES = 3;

	/**
	 * The feature id for the '<em><b>Network Interfaces</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTATION_REPOSITORY__NETWORK_INTERFACES = 4;

	/**
	 * The feature id for the '<em><b>Network Interface Performances</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTATION_REPOSITORY__NETWORK_INTERFACE_PERFORMANCES = 5;

	/**
	 * The feature id for the '<em><b>Links</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTATION_REPOSITORY__LINKS = 6;

	/**
	 * The feature id for the '<em><b>Link Performances</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTATION_REPOSITORY__LINK_PERFORMANCES = 7;

	/**
	 * The number of structural features of the '<em>Adaptation Repository</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTATION_REPOSITORY_FEATURE_COUNT = 8;

	/**
	 * The number of operations of the '<em>Adaptation Repository</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTATION_REPOSITORY_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dni.dnimm3ap.ICostable <em>ICostable</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dni.dnimm3ap.ICostable
	 * @see tools.descartes.dni.dnimm3ap.impl.DNIAPPackageImpl#getICostable()
	 * @generated
	 */
	int ICOSTABLE = 22;

	/**
	 * The feature id for the '<em><b>Cost</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ICOSTABLE__COST = 0;

	/**
	 * The number of structural features of the '<em>ICostable</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ICOSTABLE_FEATURE_COUNT = 1;

	/**
	 * The number of operations of the '<em>ICostable</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ICOSTABLE_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dni.dnimm3ap.IAdaptableEntity <em>IAdaptable Entity</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dni.dnimm3ap.IAdaptableEntity
	 * @see tools.descartes.dni.dnimm3ap.impl.DNIAPPackageImpl#getIAdaptableEntity()
	 * @generated
	 */
	int IADAPTABLE_ENTITY = 2;

	/**
	 * The feature id for the '<em><b>Cost</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IADAPTABLE_ENTITY__COST = ICOSTABLE__COST;

	/**
	 * The feature id for the '<em><b>Entity Type</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IADAPTABLE_ENTITY__ENTITY_TYPE = ICOSTABLE_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>IAdaptable Entity</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IADAPTABLE_ENTITY_FEATURE_COUNT = ICOSTABLE_FEATURE_COUNT + 1;

	/**
	 * The number of operations of the '<em>IAdaptable Entity</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IADAPTABLE_ENTITY_OPERATION_COUNT = ICOSTABLE_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dni.dnimm3ap.IAdaptableGroupableEntity <em>IAdaptable Groupable Entity</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dni.dnimm3ap.IAdaptableGroupableEntity
	 * @see tools.descartes.dni.dnimm3ap.impl.DNIAPPackageImpl#getIAdaptableGroupableEntity()
	 * @generated
	 */
	int IADAPTABLE_GROUPABLE_ENTITY = 3;

	/**
	 * The number of structural features of the '<em>IAdaptable Groupable Entity</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IADAPTABLE_GROUPABLE_ENTITY_FEATURE_COUNT = 0;

	/**
	 * The number of operations of the '<em>IAdaptable Groupable Entity</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IADAPTABLE_GROUPABLE_ENTITY_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dni.dnimm3ap.impl.AdaptableNodeImpl <em>Adaptable Node</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dni.dnimm3ap.impl.AdaptableNodeImpl
	 * @see tools.descartes.dni.dnimm3ap.impl.DNIAPPackageImpl#getAdaptableNode()
	 * @generated
	 */
	int ADAPTABLE_NODE = 4;

	/**
	 * The feature id for the '<em><b>Cost</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTABLE_NODE__COST = IADAPTABLE_ENTITY__COST;

	/**
	 * The feature id for the '<em><b>Entity Type</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTABLE_NODE__ENTITY_TYPE = IADAPTABLE_ENTITY__ENTITY_TYPE;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTABLE_NODE__NAME = IADAPTABLE_ENTITY_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>End Performance</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTABLE_NODE__END_PERFORMANCE = IADAPTABLE_ENTITY_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Intermediate Performance</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTABLE_NODE__INTERMEDIATE_PERFORMANCE = IADAPTABLE_ENTITY_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Sdn Node Performance</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTABLE_NODE__SDN_NODE_PERFORMANCE = IADAPTABLE_ENTITY_FEATURE_COUNT + 3;

	/**
	 * The feature id for the '<em><b>Network Interface</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTABLE_NODE__NETWORK_INTERFACE = IADAPTABLE_ENTITY_FEATURE_COUNT + 4;

	/**
	 * The feature id for the '<em><b>Adaptation Group</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTABLE_NODE__ADAPTATION_GROUP = IADAPTABLE_ENTITY_FEATURE_COUNT + 5;

	/**
	 * The number of structural features of the '<em>Adaptable Node</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTABLE_NODE_FEATURE_COUNT = IADAPTABLE_ENTITY_FEATURE_COUNT + 6;

	/**
	 * The number of operations of the '<em>Adaptable Node</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTABLE_NODE_OPERATION_COUNT = IADAPTABLE_ENTITY_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dni.dnimm3ap.impl.AdaptableLinkImpl <em>Adaptable Link</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dni.dnimm3ap.impl.AdaptableLinkImpl
	 * @see tools.descartes.dni.dnimm3ap.impl.DNIAPPackageImpl#getAdaptableLink()
	 * @generated
	 */
	int ADAPTABLE_LINK = 5;

	/**
	 * The feature id for the '<em><b>Cost</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTABLE_LINK__COST = IADAPTABLE_ENTITY__COST;

	/**
	 * The feature id for the '<em><b>Entity Type</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTABLE_LINK__ENTITY_TYPE = IADAPTABLE_ENTITY__ENTITY_TYPE;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTABLE_LINK__NAME = IADAPTABLE_ENTITY_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Link Performance</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTABLE_LINK__LINK_PERFORMANCE = IADAPTABLE_ENTITY_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Network Interface</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTABLE_LINK__NETWORK_INTERFACE = IADAPTABLE_ENTITY_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Adaptation Group</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTABLE_LINK__ADAPTATION_GROUP = IADAPTABLE_ENTITY_FEATURE_COUNT + 3;

	/**
	 * The number of structural features of the '<em>Adaptable Link</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTABLE_LINK_FEATURE_COUNT = IADAPTABLE_ENTITY_FEATURE_COUNT + 4;

	/**
	 * The number of operations of the '<em>Adaptable Link</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTABLE_LINK_OPERATION_COUNT = IADAPTABLE_ENTITY_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dni.dnimm3ap.impl.AdaptableLinkPerformanceImpl <em>Adaptable Link Performance</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dni.dnimm3ap.impl.AdaptableLinkPerformanceImpl
	 * @see tools.descartes.dni.dnimm3ap.impl.DNIAPPackageImpl#getAdaptableLinkPerformance()
	 * @generated
	 */
	int ADAPTABLE_LINK_PERFORMANCE = 6;

	/**
	 * The feature id for the '<em><b>Cost</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTABLE_LINK_PERFORMANCE__COST = IADAPTABLE_ENTITY__COST;

	/**
	 * The feature id for the '<em><b>Entity Type</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTABLE_LINK_PERFORMANCE__ENTITY_TYPE = IADAPTABLE_ENTITY__ENTITY_TYPE;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTABLE_LINK_PERFORMANCE__NAME = IADAPTABLE_ENTITY_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Propagation Delay</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTABLE_LINK_PERFORMANCE__PROPAGATION_DELAY = IADAPTABLE_ENTITY_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Maximal Supported Bandwidth</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTABLE_LINK_PERFORMANCE__MAXIMAL_SUPPORTED_BANDWIDTH = IADAPTABLE_ENTITY_FEATURE_COUNT + 2;

	/**
	 * The number of structural features of the '<em>Adaptable Link Performance</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTABLE_LINK_PERFORMANCE_FEATURE_COUNT = IADAPTABLE_ENTITY_FEATURE_COUNT + 3;

	/**
	 * The number of operations of the '<em>Adaptable Link Performance</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTABLE_LINK_PERFORMANCE_OPERATION_COUNT = IADAPTABLE_ENTITY_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dni.dnimm3ap.impl.AdaptableEndPerformanceImpl <em>Adaptable End Performance</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dni.dnimm3ap.impl.AdaptableEndPerformanceImpl
	 * @see tools.descartes.dni.dnimm3ap.impl.DNIAPPackageImpl#getAdaptableEndPerformance()
	 * @generated
	 */
	int ADAPTABLE_END_PERFORMANCE = 7;

	/**
	 * The feature id for the '<em><b>Cost</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTABLE_END_PERFORMANCE__COST = IADAPTABLE_ENTITY__COST;

	/**
	 * The feature id for the '<em><b>Entity Type</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTABLE_END_PERFORMANCE__ENTITY_TYPE = IADAPTABLE_ENTITY__ENTITY_TYPE;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTABLE_END_PERFORMANCE__NAME = IADAPTABLE_ENTITY_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Software Layers Delay</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTABLE_END_PERFORMANCE__SOFTWARE_LAYERS_DELAY = IADAPTABLE_ENTITY_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Adaptable End Performance</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTABLE_END_PERFORMANCE_FEATURE_COUNT = IADAPTABLE_ENTITY_FEATURE_COUNT + 2;

	/**
	 * The number of operations of the '<em>Adaptable End Performance</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTABLE_END_PERFORMANCE_OPERATION_COUNT = IADAPTABLE_ENTITY_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dni.dnimm3ap.impl.AdaptableIntermediatePerformanceImpl <em>Adaptable Intermediate Performance</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dni.dnimm3ap.impl.AdaptableIntermediatePerformanceImpl
	 * @see tools.descartes.dni.dnimm3ap.impl.DNIAPPackageImpl#getAdaptableIntermediatePerformance()
	 * @generated
	 */
	int ADAPTABLE_INTERMEDIATE_PERFORMANCE = 8;

	/**
	 * The feature id for the '<em><b>Cost</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTABLE_INTERMEDIATE_PERFORMANCE__COST = IADAPTABLE_ENTITY__COST;

	/**
	 * The feature id for the '<em><b>Entity Type</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTABLE_INTERMEDIATE_PERFORMANCE__ENTITY_TYPE = IADAPTABLE_ENTITY__ENTITY_TYPE;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTABLE_INTERMEDIATE_PERFORMANCE__NAME = IADAPTABLE_ENTITY_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Forwarding Latency</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTABLE_INTERMEDIATE_PERFORMANCE__FORWARDING_LATENCY = IADAPTABLE_ENTITY_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Forwarding Bandwidth BPS</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTABLE_INTERMEDIATE_PERFORMANCE__FORWARDING_BANDWIDTH_BPS = IADAPTABLE_ENTITY_FEATURE_COUNT + 2;

	/**
	 * The feature id for the '<em><b>Switching Capacity PPS</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTABLE_INTERMEDIATE_PERFORMANCE__SWITCHING_CAPACITY_PPS = IADAPTABLE_ENTITY_FEATURE_COUNT + 3;

	/**
	 * The number of structural features of the '<em>Adaptable Intermediate Performance</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTABLE_INTERMEDIATE_PERFORMANCE_FEATURE_COUNT = IADAPTABLE_ENTITY_FEATURE_COUNT + 4;

	/**
	 * The number of operations of the '<em>Adaptable Intermediate Performance</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTABLE_INTERMEDIATE_PERFORMANCE_OPERATION_COUNT = IADAPTABLE_ENTITY_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dni.dnimm3ap.impl.AdaptableSdnNodePerformanceImpl <em>Adaptable Sdn Node Performance</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dni.dnimm3ap.impl.AdaptableSdnNodePerformanceImpl
	 * @see tools.descartes.dni.dnimm3ap.impl.DNIAPPackageImpl#getAdaptableSdnNodePerformance()
	 * @generated
	 */
	int ADAPTABLE_SDN_NODE_PERFORMANCE = 9;

	/**
	 * The feature id for the '<em><b>Cost</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTABLE_SDN_NODE_PERFORMANCE__COST = IADAPTABLE_ENTITY__COST;

	/**
	 * The feature id for the '<em><b>Entity Type</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTABLE_SDN_NODE_PERFORMANCE__ENTITY_TYPE = IADAPTABLE_ENTITY__ENTITY_TYPE;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTABLE_SDN_NODE_PERFORMANCE__NAME = IADAPTABLE_ENTITY_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Software Switching Performance</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTABLE_SDN_NODE_PERFORMANCE__SOFTWARE_SWITCHING_PERFORMANCE = IADAPTABLE_ENTITY_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Hardware Switching Performance</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTABLE_SDN_NODE_PERFORMANCE__HARDWARE_SWITCHING_PERFORMANCE = IADAPTABLE_ENTITY_FEATURE_COUNT + 2;

	/**
	 * The number of structural features of the '<em>Adaptable Sdn Node Performance</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTABLE_SDN_NODE_PERFORMANCE_FEATURE_COUNT = IADAPTABLE_ENTITY_FEATURE_COUNT + 3;

	/**
	 * The number of operations of the '<em>Adaptable Sdn Node Performance</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTABLE_SDN_NODE_PERFORMANCE_OPERATION_COUNT = IADAPTABLE_ENTITY_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dni.dnimm3ap.impl.AdaptableNetworkInterfaceImpl <em>Adaptable Network Interface</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dni.dnimm3ap.impl.AdaptableNetworkInterfaceImpl
	 * @see tools.descartes.dni.dnimm3ap.impl.DNIAPPackageImpl#getAdaptableNetworkInterface()
	 * @generated
	 */
	int ADAPTABLE_NETWORK_INTERFACE = 10;

	/**
	 * The feature id for the '<em><b>Cost</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTABLE_NETWORK_INTERFACE__COST = IADAPTABLE_ENTITY__COST;

	/**
	 * The feature id for the '<em><b>Entity Type</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTABLE_NETWORK_INTERFACE__ENTITY_TYPE = IADAPTABLE_ENTITY__ENTITY_TYPE;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTABLE_NETWORK_INTERFACE__NAME = IADAPTABLE_ENTITY_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Network Interface Performance</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTABLE_NETWORK_INTERFACE__NETWORK_INTERFACE_PERFORMANCE = IADAPTABLE_ENTITY_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>Adaptable Network Interface</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTABLE_NETWORK_INTERFACE_FEATURE_COUNT = IADAPTABLE_ENTITY_FEATURE_COUNT + 2;

	/**
	 * The number of operations of the '<em>Adaptable Network Interface</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTABLE_NETWORK_INTERFACE_OPERATION_COUNT = IADAPTABLE_ENTITY_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dni.dnimm3ap.impl.AdaptableNetworkInterfacePerformanceImpl <em>Adaptable Network Interface Performance</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dni.dnimm3ap.impl.AdaptableNetworkInterfacePerformanceImpl
	 * @see tools.descartes.dni.dnimm3ap.impl.DNIAPPackageImpl#getAdaptableNetworkInterfacePerformance()
	 * @generated
	 */
	int ADAPTABLE_NETWORK_INTERFACE_PERFORMANCE = 11;

	/**
	 * The feature id for the '<em><b>Cost</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTABLE_NETWORK_INTERFACE_PERFORMANCE__COST = IADAPTABLE_ENTITY__COST;

	/**
	 * The feature id for the '<em><b>Entity Type</b></em>' reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTABLE_NETWORK_INTERFACE_PERFORMANCE__ENTITY_TYPE = IADAPTABLE_ENTITY__ENTITY_TYPE;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTABLE_NETWORK_INTERFACE_PERFORMANCE__NAME = IADAPTABLE_ENTITY_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Packet Processing Time</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTABLE_NETWORK_INTERFACE_PERFORMANCE__PACKET_PROCESSING_TIME = IADAPTABLE_ENTITY_FEATURE_COUNT + 1;

	/**
	 * The feature id for the '<em><b>Interface Throughput</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTABLE_NETWORK_INTERFACE_PERFORMANCE__INTERFACE_THROUGHPUT = IADAPTABLE_ENTITY_FEATURE_COUNT + 2;

	/**
	 * The number of structural features of the '<em>Adaptable Network Interface Performance</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTABLE_NETWORK_INTERFACE_PERFORMANCE_FEATURE_COUNT = IADAPTABLE_ENTITY_FEATURE_COUNT + 3;

	/**
	 * The number of operations of the '<em>Adaptable Network Interface Performance</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTABLE_NETWORK_INTERFACE_PERFORMANCE_OPERATION_COUNT = IADAPTABLE_ENTITY_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dni.dnimm3ap.impl.AdaptationGroupsImpl <em>Adaptation Groups</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dni.dnimm3ap.impl.AdaptationGroupsImpl
	 * @see tools.descartes.dni.dnimm3ap.impl.DNIAPPackageImpl#getAdaptationGroups()
	 * @generated
	 */
	int ADAPTATION_GROUPS = 12;

	/**
	 * The feature id for the '<em><b>Nodes</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTATION_GROUPS__NODES = 0;

	/**
	 * The feature id for the '<em><b>Links</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTATION_GROUPS__LINKS = 1;

	/**
	 * The number of structural features of the '<em>Adaptation Groups</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTATION_GROUPS_FEATURE_COUNT = 2;

	/**
	 * The number of operations of the '<em>Adaptation Groups</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTATION_GROUPS_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dni.dnimm3ap.IAdaptationGroup <em>IAdaptation Group</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dni.dnimm3ap.IAdaptationGroup
	 * @see tools.descartes.dni.dnimm3ap.impl.DNIAPPackageImpl#getIAdaptationGroup()
	 * @generated
	 */
	int IADAPTATION_GROUP = 13;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IADAPTATION_GROUP__NAME = DNIPackage.NAMED_ELEMENT__NAME;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IADAPTATION_GROUP__DESCRIPTION = DNIPackage.NAMED_ELEMENT__DESCRIPTION;

	/**
	 * The feature id for the '<em><b>Uid</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IADAPTATION_GROUP__UID = DNIPackage.NAMED_ELEMENT_FEATURE_COUNT + 0;

	/**
	 * The feature id for the '<em><b>Uid generated</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IADAPTATION_GROUP__UID_GENERATED = DNIPackage.NAMED_ELEMENT_FEATURE_COUNT + 1;

	/**
	 * The number of structural features of the '<em>IAdaptation Group</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IADAPTATION_GROUP_FEATURE_COUNT = DNIPackage.NAMED_ELEMENT_FEATURE_COUNT + 2;

	/**
	 * The number of operations of the '<em>IAdaptation Group</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int IADAPTATION_GROUP_OPERATION_COUNT = DNIPackage.NAMED_ELEMENT_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dni.dnimm3ap.impl.NodeAdaptationGroupImpl <em>Node Adaptation Group</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dni.dnimm3ap.impl.NodeAdaptationGroupImpl
	 * @see tools.descartes.dni.dnimm3ap.impl.DNIAPPackageImpl#getNodeAdaptationGroup()
	 * @generated
	 */
	int NODE_ADAPTATION_GROUP = 14;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NODE_ADAPTATION_GROUP__NAME = IADAPTATION_GROUP__NAME;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NODE_ADAPTATION_GROUP__DESCRIPTION = IADAPTATION_GROUP__DESCRIPTION;

	/**
	 * The feature id for the '<em><b>Uid</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NODE_ADAPTATION_GROUP__UID = IADAPTATION_GROUP__UID;

	/**
	 * The feature id for the '<em><b>Uid generated</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NODE_ADAPTATION_GROUP__UID_GENERATED = IADAPTATION_GROUP__UID_GENERATED;

	/**
	 * The feature id for the '<em><b>Items</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NODE_ADAPTATION_GROUP__ITEMS = IADAPTATION_GROUP_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Node Adaptation Group</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NODE_ADAPTATION_GROUP_FEATURE_COUNT = IADAPTATION_GROUP_FEATURE_COUNT + 1;

	/**
	 * The number of operations of the '<em>Node Adaptation Group</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int NODE_ADAPTATION_GROUP_OPERATION_COUNT = IADAPTATION_GROUP_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dni.dnimm3ap.impl.LinkAdaptationGroupImpl <em>Link Adaptation Group</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dni.dnimm3ap.impl.LinkAdaptationGroupImpl
	 * @see tools.descartes.dni.dnimm3ap.impl.DNIAPPackageImpl#getLinkAdaptationGroup()
	 * @generated
	 */
	int LINK_ADAPTATION_GROUP = 15;

	/**
	 * The feature id for the '<em><b>Name</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINK_ADAPTATION_GROUP__NAME = IADAPTATION_GROUP__NAME;

	/**
	 * The feature id for the '<em><b>Description</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINK_ADAPTATION_GROUP__DESCRIPTION = IADAPTATION_GROUP__DESCRIPTION;

	/**
	 * The feature id for the '<em><b>Uid</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINK_ADAPTATION_GROUP__UID = IADAPTATION_GROUP__UID;

	/**
	 * The feature id for the '<em><b>Uid generated</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINK_ADAPTATION_GROUP__UID_GENERATED = IADAPTATION_GROUP__UID_GENERATED;

	/**
	 * The feature id for the '<em><b>Items</b></em>' reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINK_ADAPTATION_GROUP__ITEMS = IADAPTATION_GROUP_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Link Adaptation Group</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINK_ADAPTATION_GROUP_FEATURE_COUNT = IADAPTATION_GROUP_FEATURE_COUNT + 1;

	/**
	 * The number of operations of the '<em>Link Adaptation Group</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int LINK_ADAPTATION_GROUP_OPERATION_COUNT = IADAPTATION_GROUP_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dni.dnimm3ap.AlternativeDependency <em>Alternative Dependency</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dni.dnimm3ap.AlternativeDependency
	 * @see tools.descartes.dni.dnimm3ap.impl.DNIAPPackageImpl#getAlternativeDependency()
	 * @generated
	 */
	int ALTERNATIVE_DEPENDENCY = 16;

	/**
	 * The number of structural features of the '<em>Alternative Dependency</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ALTERNATIVE_DEPENDENCY_FEATURE_COUNT = 0;

	/**
	 * The number of operations of the '<em>Alternative Dependency</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ALTERNATIVE_DEPENDENCY_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dni.dnimm3ap.impl.AlternativeDependencySetImpl <em>Alternative Dependency Set</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dni.dnimm3ap.impl.AlternativeDependencySetImpl
	 * @see tools.descartes.dni.dnimm3ap.impl.DNIAPPackageImpl#getAlternativeDependencySet()
	 * @generated
	 */
	int ALTERNATIVE_DEPENDENCY_SET = 17;

	/**
	 * The feature id for the '<em><b>Alternative</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ALTERNATIVE_DEPENDENCY_SET__ALTERNATIVE = ALTERNATIVE_DEPENDENCY_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Alternative Dependency Set</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ALTERNATIVE_DEPENDENCY_SET_FEATURE_COUNT = ALTERNATIVE_DEPENDENCY_FEATURE_COUNT + 1;

	/**
	 * The number of operations of the '<em>Alternative Dependency Set</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ALTERNATIVE_DEPENDENCY_SET_OPERATION_COUNT = ALTERNATIVE_DEPENDENCY_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dni.dnimm3ap.impl.AdaptableDependencyImpl <em>Adaptable Dependency</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dni.dnimm3ap.impl.AdaptableDependencyImpl
	 * @see tools.descartes.dni.dnimm3ap.impl.DNIAPPackageImpl#getAdaptableDependency()
	 * @generated
	 */
	int ADAPTABLE_DEPENDENCY = 18;

	/**
	 * The feature id for the '<em><b>Cost</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTABLE_DEPENDENCY__COST = ICOSTABLE__COST;

	/**
	 * The feature id for the '<em><b>Parameter</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTABLE_DEPENDENCY__PARAMETER = ICOSTABLE_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Adaptable Dependency</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTABLE_DEPENDENCY_FEATURE_COUNT = ICOSTABLE_FEATURE_COUNT + 1;

	/**
	 * The number of operations of the '<em>Adaptable Dependency</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTABLE_DEPENDENCY_OPERATION_COUNT = ICOSTABLE_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dni.dnimm3ap.AlternativeVariable <em>Alternative Variable</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dni.dnimm3ap.AlternativeVariable
	 * @see tools.descartes.dni.dnimm3ap.impl.DNIAPPackageImpl#getAlternativeVariable()
	 * @generated
	 */
	int ALTERNATIVE_VARIABLE = 19;

	/**
	 * The number of structural features of the '<em>Alternative Variable</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ALTERNATIVE_VARIABLE_FEATURE_COUNT = 0;

	/**
	 * The number of operations of the '<em>Alternative Variable</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ALTERNATIVE_VARIABLE_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dni.dnimm3ap.impl.AlternativeVariableSetImpl <em>Alternative Variable Set</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dni.dnimm3ap.impl.AlternativeVariableSetImpl
	 * @see tools.descartes.dni.dnimm3ap.impl.DNIAPPackageImpl#getAlternativeVariableSet()
	 * @generated
	 */
	int ALTERNATIVE_VARIABLE_SET = 20;

	/**
	 * The feature id for the '<em><b>Alternative</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ALTERNATIVE_VARIABLE_SET__ALTERNATIVE = ALTERNATIVE_VARIABLE_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Alternative Variable Set</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ALTERNATIVE_VARIABLE_SET_FEATURE_COUNT = ALTERNATIVE_VARIABLE_FEATURE_COUNT + 1;

	/**
	 * The number of operations of the '<em>Alternative Variable Set</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ALTERNATIVE_VARIABLE_SET_OPERATION_COUNT = ALTERNATIVE_VARIABLE_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dni.dnimm3ap.impl.AdaptableVariableImpl <em>Adaptable Variable</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dni.dnimm3ap.impl.AdaptableVariableImpl
	 * @see tools.descartes.dni.dnimm3ap.impl.DNIAPPackageImpl#getAdaptableVariable()
	 * @generated
	 */
	int ADAPTABLE_VARIABLE = 21;

	/**
	 * The feature id for the '<em><b>Cost</b></em>' containment reference list.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTABLE_VARIABLE__COST = ICOSTABLE__COST;

	/**
	 * The feature id for the '<em><b>Parameter</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTABLE_VARIABLE__PARAMETER = ICOSTABLE_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Adaptable Variable</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTABLE_VARIABLE_FEATURE_COUNT = ICOSTABLE_FEATURE_COUNT + 1;

	/**
	 * The number of operations of the '<em>Adaptable Variable</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ADAPTABLE_VARIABLE_OPERATION_COUNT = ICOSTABLE_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dni.dnimm3ap.impl.CostImpl <em>Cost</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dni.dnimm3ap.impl.CostImpl
	 * @see tools.descartes.dni.dnimm3ap.impl.DNIAPPackageImpl#getCost()
	 * @generated
	 */
	int COST = 23;

	/**
	 * The feature id for the '<em><b>Cost Function</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COST__COST_FUNCTION = 0;

	/**
	 * The number of structural features of the '<em>Cost</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COST_FEATURE_COUNT = 1;

	/**
	 * The number of operations of the '<em>Cost</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int COST_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dni.dnimm3ap.impl.InvestmentImpl <em>Investment</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dni.dnimm3ap.impl.InvestmentImpl
	 * @see tools.descartes.dni.dnimm3ap.impl.DNIAPPackageImpl#getInvestment()
	 * @generated
	 */
	int INVESTMENT = 24;

	/**
	 * The feature id for the '<em><b>Cost Function</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INVESTMENT__COST_FUNCTION = COST__COST_FUNCTION;

	/**
	 * The number of structural features of the '<em>Investment</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INVESTMENT_FEATURE_COUNT = COST_FEATURE_COUNT + 0;

	/**
	 * The number of operations of the '<em>Investment</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int INVESTMENT_OPERATION_COUNT = COST_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dni.dnimm3ap.impl.HandlingTimeImpl <em>Handling Time</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dni.dnimm3ap.impl.HandlingTimeImpl
	 * @see tools.descartes.dni.dnimm3ap.impl.DNIAPPackageImpl#getHandlingTime()
	 * @generated
	 */
	int HANDLING_TIME = 25;

	/**
	 * The feature id for the '<em><b>Cost Function</b></em>' containment reference.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HANDLING_TIME__COST_FUNCTION = COST__COST_FUNCTION;

	/**
	 * The number of structural features of the '<em>Handling Time</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HANDLING_TIME_FEATURE_COUNT = COST_FEATURE_COUNT + 0;

	/**
	 * The number of operations of the '<em>Handling Time</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int HANDLING_TIME_OPERATION_COUNT = COST_OPERATION_COUNT + 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dni.dnimm3ap.ICostFunction <em>ICost Function</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dni.dnimm3ap.ICostFunction
	 * @see tools.descartes.dni.dnimm3ap.impl.DNIAPPackageImpl#getICostFunction()
	 * @generated
	 */
	int ICOST_FUNCTION = 26;

	/**
	 * The number of structural features of the '<em>ICost Function</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ICOST_FUNCTION_FEATURE_COUNT = 0;

	/**
	 * The number of operations of the '<em>ICost Function</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int ICOST_FUNCTION_OPERATION_COUNT = 0;

	/**
	 * The meta object id for the '{@link tools.descartes.dni.dnimm3ap.impl.FixedCostFunctionImpl <em>Fixed Cost Function</em>}' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @see tools.descartes.dni.dnimm3ap.impl.FixedCostFunctionImpl
	 * @see tools.descartes.dni.dnimm3ap.impl.DNIAPPackageImpl#getFixedCostFunction()
	 * @generated
	 */
	int FIXED_COST_FUNCTION = 27;

	/**
	 * The feature id for the '<em><b>Value</b></em>' attribute.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FIXED_COST_FUNCTION__VALUE = ICOST_FUNCTION_FEATURE_COUNT + 0;

	/**
	 * The number of structural features of the '<em>Fixed Cost Function</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FIXED_COST_FUNCTION_FEATURE_COUNT = ICOST_FUNCTION_FEATURE_COUNT + 1;

	/**
	 * The number of operations of the '<em>Fixed Cost Function</em>' class.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 * @ordered
	 */
	int FIXED_COST_FUNCTION_OPERATION_COUNT = ICOST_FUNCTION_OPERATION_COUNT + 0;


	/**
	 * Returns the meta object for class '{@link tools.descartes.dni.dnimm3ap.AdaptationPoints <em>Adaptation Points</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Adaptation Points</em>'.
	 * @see tools.descartes.dni.dnimm3ap.AdaptationPoints
	 * @generated
	 */
	EClass getAdaptationPoints();

	/**
	 * Returns the meta object for the containment reference '{@link tools.descartes.dni.dnimm3ap.AdaptationPoints#getRepositories <em>Repositories</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Repositories</em>'.
	 * @see tools.descartes.dni.dnimm3ap.AdaptationPoints#getRepositories()
	 * @see #getAdaptationPoints()
	 * @generated
	 */
	EReference getAdaptationPoints_Repositories();

	/**
	 * Returns the meta object for the containment reference '{@link tools.descartes.dni.dnimm3ap.AdaptationPoints#getGroups <em>Groups</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Groups</em>'.
	 * @see tools.descartes.dni.dnimm3ap.AdaptationPoints#getGroups()
	 * @see #getAdaptationPoints()
	 * @generated
	 */
	EReference getAdaptationPoints_Groups();

	/**
	 * Returns the meta object for the reference '{@link tools.descartes.dni.dnimm3ap.AdaptationPoints#getNetworkInfrastructure <em>Network Infrastructure</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Network Infrastructure</em>'.
	 * @see tools.descartes.dni.dnimm3ap.AdaptationPoints#getNetworkInfrastructure()
	 * @see #getAdaptationPoints()
	 * @generated
	 */
	EReference getAdaptationPoints_NetworkInfrastructure();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dni.dnimm3ap.AdaptationRepository <em>Adaptation Repository</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Adaptation Repository</em>'.
	 * @see tools.descartes.dni.dnimm3ap.AdaptationRepository
	 * @generated
	 */
	EClass getAdaptationRepository();

	/**
	 * Returns the meta object for the containment reference list '{@link tools.descartes.dni.dnimm3ap.AdaptationRepository#getNodes <em>Nodes</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Nodes</em>'.
	 * @see tools.descartes.dni.dnimm3ap.AdaptationRepository#getNodes()
	 * @see #getAdaptationRepository()
	 * @generated
	 */
	EReference getAdaptationRepository_Nodes();

	/**
	 * Returns the meta object for the containment reference list '{@link tools.descartes.dni.dnimm3ap.AdaptationRepository#getEndPerformances <em>End Performances</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>End Performances</em>'.
	 * @see tools.descartes.dni.dnimm3ap.AdaptationRepository#getEndPerformances()
	 * @see #getAdaptationRepository()
	 * @generated
	 */
	EReference getAdaptationRepository_EndPerformances();

	/**
	 * Returns the meta object for the containment reference list '{@link tools.descartes.dni.dnimm3ap.AdaptationRepository#getIntermediatePerformances <em>Intermediate Performances</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Intermediate Performances</em>'.
	 * @see tools.descartes.dni.dnimm3ap.AdaptationRepository#getIntermediatePerformances()
	 * @see #getAdaptationRepository()
	 * @generated
	 */
	EReference getAdaptationRepository_IntermediatePerformances();

	/**
	 * Returns the meta object for the containment reference list '{@link tools.descartes.dni.dnimm3ap.AdaptationRepository#getSdnNodePerformances <em>Sdn Node Performances</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Sdn Node Performances</em>'.
	 * @see tools.descartes.dni.dnimm3ap.AdaptationRepository#getSdnNodePerformances()
	 * @see #getAdaptationRepository()
	 * @generated
	 */
	EReference getAdaptationRepository_SdnNodePerformances();

	/**
	 * Returns the meta object for the containment reference list '{@link tools.descartes.dni.dnimm3ap.AdaptationRepository#getNetworkInterfaces <em>Network Interfaces</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Network Interfaces</em>'.
	 * @see tools.descartes.dni.dnimm3ap.AdaptationRepository#getNetworkInterfaces()
	 * @see #getAdaptationRepository()
	 * @generated
	 */
	EReference getAdaptationRepository_NetworkInterfaces();

	/**
	 * Returns the meta object for the containment reference list '{@link tools.descartes.dni.dnimm3ap.AdaptationRepository#getNetworkInterfacePerformances <em>Network Interface Performances</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Network Interface Performances</em>'.
	 * @see tools.descartes.dni.dnimm3ap.AdaptationRepository#getNetworkInterfacePerformances()
	 * @see #getAdaptationRepository()
	 * @generated
	 */
	EReference getAdaptationRepository_NetworkInterfacePerformances();

	/**
	 * Returns the meta object for the containment reference list '{@link tools.descartes.dni.dnimm3ap.AdaptationRepository#getLinks <em>Links</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Links</em>'.
	 * @see tools.descartes.dni.dnimm3ap.AdaptationRepository#getLinks()
	 * @see #getAdaptationRepository()
	 * @generated
	 */
	EReference getAdaptationRepository_Links();

	/**
	 * Returns the meta object for the containment reference list '{@link tools.descartes.dni.dnimm3ap.AdaptationRepository#getLinkPerformances <em>Link Performances</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Link Performances</em>'.
	 * @see tools.descartes.dni.dnimm3ap.AdaptationRepository#getLinkPerformances()
	 * @see #getAdaptationRepository()
	 * @generated
	 */
	EReference getAdaptationRepository_LinkPerformances();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dni.dnimm3ap.IAdaptableEntity <em>IAdaptable Entity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>IAdaptable Entity</em>'.
	 * @see tools.descartes.dni.dnimm3ap.IAdaptableEntity
	 * @generated
	 */
	EClass getIAdaptableEntity();

	/**
	 * Returns the meta object for the reference '{@link tools.descartes.dni.dnimm3ap.IAdaptableEntity#getEntityType <em>Entity Type</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Entity Type</em>'.
	 * @see tools.descartes.dni.dnimm3ap.IAdaptableEntity#getEntityType()
	 * @see #getIAdaptableEntity()
	 * @generated
	 */
	EReference getIAdaptableEntity_EntityType();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dni.dnimm3ap.IAdaptableGroupableEntity <em>IAdaptable Groupable Entity</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>IAdaptable Groupable Entity</em>'.
	 * @see tools.descartes.dni.dnimm3ap.IAdaptableGroupableEntity
	 * @generated
	 */
	EClass getIAdaptableGroupableEntity();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dni.dnimm3ap.AdaptableNode <em>Adaptable Node</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Adaptable Node</em>'.
	 * @see tools.descartes.dni.dnimm3ap.AdaptableNode
	 * @generated
	 */
	EClass getAdaptableNode();

	/**
	 * Returns the meta object for the attribute '{@link tools.descartes.dni.dnimm3ap.AdaptableNode#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see tools.descartes.dni.dnimm3ap.AdaptableNode#getName()
	 * @see #getAdaptableNode()
	 * @generated
	 */
	EAttribute getAdaptableNode_Name();

	/**
	 * Returns the meta object for the reference list '{@link tools.descartes.dni.dnimm3ap.AdaptableNode#getEndPerformance <em>End Performance</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>End Performance</em>'.
	 * @see tools.descartes.dni.dnimm3ap.AdaptableNode#getEndPerformance()
	 * @see #getAdaptableNode()
	 * @generated
	 */
	EReference getAdaptableNode_EndPerformance();

	/**
	 * Returns the meta object for the reference list '{@link tools.descartes.dni.dnimm3ap.AdaptableNode#getIntermediatePerformance <em>Intermediate Performance</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Intermediate Performance</em>'.
	 * @see tools.descartes.dni.dnimm3ap.AdaptableNode#getIntermediatePerformance()
	 * @see #getAdaptableNode()
	 * @generated
	 */
	EReference getAdaptableNode_IntermediatePerformance();

	/**
	 * Returns the meta object for the reference list '{@link tools.descartes.dni.dnimm3ap.AdaptableNode#getSdnNodePerformance <em>Sdn Node Performance</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Sdn Node Performance</em>'.
	 * @see tools.descartes.dni.dnimm3ap.AdaptableNode#getSdnNodePerformance()
	 * @see #getAdaptableNode()
	 * @generated
	 */
	EReference getAdaptableNode_SdnNodePerformance();

	/**
	 * Returns the meta object for the reference list '{@link tools.descartes.dni.dnimm3ap.AdaptableNode#getNetworkInterface <em>Network Interface</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Network Interface</em>'.
	 * @see tools.descartes.dni.dnimm3ap.AdaptableNode#getNetworkInterface()
	 * @see #getAdaptableNode()
	 * @generated
	 */
	EReference getAdaptableNode_NetworkInterface();

	/**
	 * Returns the meta object for the reference '{@link tools.descartes.dni.dnimm3ap.AdaptableNode#getAdaptationGroup <em>Adaptation Group</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Adaptation Group</em>'.
	 * @see tools.descartes.dni.dnimm3ap.AdaptableNode#getAdaptationGroup()
	 * @see #getAdaptableNode()
	 * @generated
	 */
	EReference getAdaptableNode_AdaptationGroup();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dni.dnimm3ap.AdaptableLink <em>Adaptable Link</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Adaptable Link</em>'.
	 * @see tools.descartes.dni.dnimm3ap.AdaptableLink
	 * @generated
	 */
	EClass getAdaptableLink();

	/**
	 * Returns the meta object for the attribute '{@link tools.descartes.dni.dnimm3ap.AdaptableLink#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see tools.descartes.dni.dnimm3ap.AdaptableLink#getName()
	 * @see #getAdaptableLink()
	 * @generated
	 */
	EAttribute getAdaptableLink_Name();

	/**
	 * Returns the meta object for the reference list '{@link tools.descartes.dni.dnimm3ap.AdaptableLink#getLinkPerformance <em>Link Performance</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Link Performance</em>'.
	 * @see tools.descartes.dni.dnimm3ap.AdaptableLink#getLinkPerformance()
	 * @see #getAdaptableLink()
	 * @generated
	 */
	EReference getAdaptableLink_LinkPerformance();

	/**
	 * Returns the meta object for the reference list '{@link tools.descartes.dni.dnimm3ap.AdaptableLink#getNetworkInterface <em>Network Interface</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Network Interface</em>'.
	 * @see tools.descartes.dni.dnimm3ap.AdaptableLink#getNetworkInterface()
	 * @see #getAdaptableLink()
	 * @generated
	 */
	EReference getAdaptableLink_NetworkInterface();

	/**
	 * Returns the meta object for the reference '{@link tools.descartes.dni.dnimm3ap.AdaptableLink#getAdaptationGroup <em>Adaptation Group</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference '<em>Adaptation Group</em>'.
	 * @see tools.descartes.dni.dnimm3ap.AdaptableLink#getAdaptationGroup()
	 * @see #getAdaptableLink()
	 * @generated
	 */
	EReference getAdaptableLink_AdaptationGroup();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dni.dnimm3ap.AdaptableLinkPerformance <em>Adaptable Link Performance</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Adaptable Link Performance</em>'.
	 * @see tools.descartes.dni.dnimm3ap.AdaptableLinkPerformance
	 * @generated
	 */
	EClass getAdaptableLinkPerformance();

	/**
	 * Returns the meta object for the attribute '{@link tools.descartes.dni.dnimm3ap.AdaptableLinkPerformance#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see tools.descartes.dni.dnimm3ap.AdaptableLinkPerformance#getName()
	 * @see #getAdaptableLinkPerformance()
	 * @generated
	 */
	EAttribute getAdaptableLinkPerformance_Name();

	/**
	 * Returns the meta object for the containment reference '{@link tools.descartes.dni.dnimm3ap.AdaptableLinkPerformance#getPropagationDelay <em>Propagation Delay</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Propagation Delay</em>'.
	 * @see tools.descartes.dni.dnimm3ap.AdaptableLinkPerformance#getPropagationDelay()
	 * @see #getAdaptableLinkPerformance()
	 * @generated
	 */
	EReference getAdaptableLinkPerformance_PropagationDelay();

	/**
	 * Returns the meta object for the containment reference '{@link tools.descartes.dni.dnimm3ap.AdaptableLinkPerformance#getMaximalSupportedBandwidth <em>Maximal Supported Bandwidth</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Maximal Supported Bandwidth</em>'.
	 * @see tools.descartes.dni.dnimm3ap.AdaptableLinkPerformance#getMaximalSupportedBandwidth()
	 * @see #getAdaptableLinkPerformance()
	 * @generated
	 */
	EReference getAdaptableLinkPerformance_MaximalSupportedBandwidth();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dni.dnimm3ap.AdaptableEndPerformance <em>Adaptable End Performance</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Adaptable End Performance</em>'.
	 * @see tools.descartes.dni.dnimm3ap.AdaptableEndPerformance
	 * @generated
	 */
	EClass getAdaptableEndPerformance();

	/**
	 * Returns the meta object for the attribute '{@link tools.descartes.dni.dnimm3ap.AdaptableEndPerformance#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see tools.descartes.dni.dnimm3ap.AdaptableEndPerformance#getName()
	 * @see #getAdaptableEndPerformance()
	 * @generated
	 */
	EAttribute getAdaptableEndPerformance_Name();

	/**
	 * Returns the meta object for the containment reference '{@link tools.descartes.dni.dnimm3ap.AdaptableEndPerformance#getSoftwareLayersDelay <em>Software Layers Delay</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Software Layers Delay</em>'.
	 * @see tools.descartes.dni.dnimm3ap.AdaptableEndPerformance#getSoftwareLayersDelay()
	 * @see #getAdaptableEndPerformance()
	 * @generated
	 */
	EReference getAdaptableEndPerformance_SoftwareLayersDelay();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dni.dnimm3ap.AdaptableIntermediatePerformance <em>Adaptable Intermediate Performance</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Adaptable Intermediate Performance</em>'.
	 * @see tools.descartes.dni.dnimm3ap.AdaptableIntermediatePerformance
	 * @generated
	 */
	EClass getAdaptableIntermediatePerformance();

	/**
	 * Returns the meta object for the attribute '{@link tools.descartes.dni.dnimm3ap.AdaptableIntermediatePerformance#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see tools.descartes.dni.dnimm3ap.AdaptableIntermediatePerformance#getName()
	 * @see #getAdaptableIntermediatePerformance()
	 * @generated
	 */
	EAttribute getAdaptableIntermediatePerformance_Name();

	/**
	 * Returns the meta object for the containment reference '{@link tools.descartes.dni.dnimm3ap.AdaptableIntermediatePerformance#getForwardingLatency <em>Forwarding Latency</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Forwarding Latency</em>'.
	 * @see tools.descartes.dni.dnimm3ap.AdaptableIntermediatePerformance#getForwardingLatency()
	 * @see #getAdaptableIntermediatePerformance()
	 * @generated
	 */
	EReference getAdaptableIntermediatePerformance_ForwardingLatency();

	/**
	 * Returns the meta object for the containment reference '{@link tools.descartes.dni.dnimm3ap.AdaptableIntermediatePerformance#getForwardingBandwidthBPS <em>Forwarding Bandwidth BPS</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Forwarding Bandwidth BPS</em>'.
	 * @see tools.descartes.dni.dnimm3ap.AdaptableIntermediatePerformance#getForwardingBandwidthBPS()
	 * @see #getAdaptableIntermediatePerformance()
	 * @generated
	 */
	EReference getAdaptableIntermediatePerformance_ForwardingBandwidthBPS();

	/**
	 * Returns the meta object for the containment reference '{@link tools.descartes.dni.dnimm3ap.AdaptableIntermediatePerformance#getSwitchingCapacityPPS <em>Switching Capacity PPS</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Switching Capacity PPS</em>'.
	 * @see tools.descartes.dni.dnimm3ap.AdaptableIntermediatePerformance#getSwitchingCapacityPPS()
	 * @see #getAdaptableIntermediatePerformance()
	 * @generated
	 */
	EReference getAdaptableIntermediatePerformance_SwitchingCapacityPPS();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dni.dnimm3ap.AdaptableSdnNodePerformance <em>Adaptable Sdn Node Performance</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Adaptable Sdn Node Performance</em>'.
	 * @see tools.descartes.dni.dnimm3ap.AdaptableSdnNodePerformance
	 * @generated
	 */
	EClass getAdaptableSdnNodePerformance();

	/**
	 * Returns the meta object for the attribute '{@link tools.descartes.dni.dnimm3ap.AdaptableSdnNodePerformance#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see tools.descartes.dni.dnimm3ap.AdaptableSdnNodePerformance#getName()
	 * @see #getAdaptableSdnNodePerformance()
	 * @generated
	 */
	EAttribute getAdaptableSdnNodePerformance_Name();

	/**
	 * Returns the meta object for the reference list '{@link tools.descartes.dni.dnimm3ap.AdaptableSdnNodePerformance#getSoftwareSwitchingPerformance <em>Software Switching Performance</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Software Switching Performance</em>'.
	 * @see tools.descartes.dni.dnimm3ap.AdaptableSdnNodePerformance#getSoftwareSwitchingPerformance()
	 * @see #getAdaptableSdnNodePerformance()
	 * @generated
	 */
	EReference getAdaptableSdnNodePerformance_SoftwareSwitchingPerformance();

	/**
	 * Returns the meta object for the reference list '{@link tools.descartes.dni.dnimm3ap.AdaptableSdnNodePerformance#getHardwareSwitchingPerformance <em>Hardware Switching Performance</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Hardware Switching Performance</em>'.
	 * @see tools.descartes.dni.dnimm3ap.AdaptableSdnNodePerformance#getHardwareSwitchingPerformance()
	 * @see #getAdaptableSdnNodePerformance()
	 * @generated
	 */
	EReference getAdaptableSdnNodePerformance_HardwareSwitchingPerformance();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dni.dnimm3ap.AdaptableNetworkInterface <em>Adaptable Network Interface</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Adaptable Network Interface</em>'.
	 * @see tools.descartes.dni.dnimm3ap.AdaptableNetworkInterface
	 * @generated
	 */
	EClass getAdaptableNetworkInterface();

	/**
	 * Returns the meta object for the attribute '{@link tools.descartes.dni.dnimm3ap.AdaptableNetworkInterface#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see tools.descartes.dni.dnimm3ap.AdaptableNetworkInterface#getName()
	 * @see #getAdaptableNetworkInterface()
	 * @generated
	 */
	EAttribute getAdaptableNetworkInterface_Name();

	/**
	 * Returns the meta object for the reference list '{@link tools.descartes.dni.dnimm3ap.AdaptableNetworkInterface#getNetworkInterfacePerformance <em>Network Interface Performance</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Network Interface Performance</em>'.
	 * @see tools.descartes.dni.dnimm3ap.AdaptableNetworkInterface#getNetworkInterfacePerformance()
	 * @see #getAdaptableNetworkInterface()
	 * @generated
	 */
	EReference getAdaptableNetworkInterface_NetworkInterfacePerformance();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dni.dnimm3ap.AdaptableNetworkInterfacePerformance <em>Adaptable Network Interface Performance</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Adaptable Network Interface Performance</em>'.
	 * @see tools.descartes.dni.dnimm3ap.AdaptableNetworkInterfacePerformance
	 * @generated
	 */
	EClass getAdaptableNetworkInterfacePerformance();

	/**
	 * Returns the meta object for the attribute '{@link tools.descartes.dni.dnimm3ap.AdaptableNetworkInterfacePerformance#getName <em>Name</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Name</em>'.
	 * @see tools.descartes.dni.dnimm3ap.AdaptableNetworkInterfacePerformance#getName()
	 * @see #getAdaptableNetworkInterfacePerformance()
	 * @generated
	 */
	EAttribute getAdaptableNetworkInterfacePerformance_Name();

	/**
	 * Returns the meta object for the containment reference '{@link tools.descartes.dni.dnimm3ap.AdaptableNetworkInterfacePerformance#getPacketProcessingTime <em>Packet Processing Time</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Packet Processing Time</em>'.
	 * @see tools.descartes.dni.dnimm3ap.AdaptableNetworkInterfacePerformance#getPacketProcessingTime()
	 * @see #getAdaptableNetworkInterfacePerformance()
	 * @generated
	 */
	EReference getAdaptableNetworkInterfacePerformance_PacketProcessingTime();

	/**
	 * Returns the meta object for the containment reference '{@link tools.descartes.dni.dnimm3ap.AdaptableNetworkInterfacePerformance#getInterfaceThroughput <em>Interface Throughput</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Interface Throughput</em>'.
	 * @see tools.descartes.dni.dnimm3ap.AdaptableNetworkInterfacePerformance#getInterfaceThroughput()
	 * @see #getAdaptableNetworkInterfacePerformance()
	 * @generated
	 */
	EReference getAdaptableNetworkInterfacePerformance_InterfaceThroughput();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dni.dnimm3ap.AdaptationGroups <em>Adaptation Groups</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Adaptation Groups</em>'.
	 * @see tools.descartes.dni.dnimm3ap.AdaptationGroups
	 * @generated
	 */
	EClass getAdaptationGroups();

	/**
	 * Returns the meta object for the containment reference list '{@link tools.descartes.dni.dnimm3ap.AdaptationGroups#getNodes <em>Nodes</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Nodes</em>'.
	 * @see tools.descartes.dni.dnimm3ap.AdaptationGroups#getNodes()
	 * @see #getAdaptationGroups()
	 * @generated
	 */
	EReference getAdaptationGroups_Nodes();

	/**
	 * Returns the meta object for the containment reference list '{@link tools.descartes.dni.dnimm3ap.AdaptationGroups#getLinks <em>Links</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Links</em>'.
	 * @see tools.descartes.dni.dnimm3ap.AdaptationGroups#getLinks()
	 * @see #getAdaptationGroups()
	 * @generated
	 */
	EReference getAdaptationGroups_Links();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dni.dnimm3ap.IAdaptationGroup <em>IAdaptation Group</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>IAdaptation Group</em>'.
	 * @see tools.descartes.dni.dnimm3ap.IAdaptationGroup
	 * @generated
	 */
	EClass getIAdaptationGroup();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dni.dnimm3ap.NodeAdaptationGroup <em>Node Adaptation Group</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Node Adaptation Group</em>'.
	 * @see tools.descartes.dni.dnimm3ap.NodeAdaptationGroup
	 * @generated
	 */
	EClass getNodeAdaptationGroup();

	/**
	 * Returns the meta object for the reference list '{@link tools.descartes.dni.dnimm3ap.NodeAdaptationGroup#getItems <em>Items</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Items</em>'.
	 * @see tools.descartes.dni.dnimm3ap.NodeAdaptationGroup#getItems()
	 * @see #getNodeAdaptationGroup()
	 * @generated
	 */
	EReference getNodeAdaptationGroup_Items();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dni.dnimm3ap.LinkAdaptationGroup <em>Link Adaptation Group</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Link Adaptation Group</em>'.
	 * @see tools.descartes.dni.dnimm3ap.LinkAdaptationGroup
	 * @generated
	 */
	EClass getLinkAdaptationGroup();

	/**
	 * Returns the meta object for the reference list '{@link tools.descartes.dni.dnimm3ap.LinkAdaptationGroup#getItems <em>Items</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the reference list '<em>Items</em>'.
	 * @see tools.descartes.dni.dnimm3ap.LinkAdaptationGroup#getItems()
	 * @see #getLinkAdaptationGroup()
	 * @generated
	 */
	EReference getLinkAdaptationGroup_Items();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dni.dnimm3ap.AlternativeDependency <em>Alternative Dependency</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Alternative Dependency</em>'.
	 * @see tools.descartes.dni.dnimm3ap.AlternativeDependency
	 * @generated
	 */
	EClass getAlternativeDependency();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dni.dnimm3ap.AlternativeDependencySet <em>Alternative Dependency Set</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Alternative Dependency Set</em>'.
	 * @see tools.descartes.dni.dnimm3ap.AlternativeDependencySet
	 * @generated
	 */
	EClass getAlternativeDependencySet();

	/**
	 * Returns the meta object for the containment reference list '{@link tools.descartes.dni.dnimm3ap.AlternativeDependencySet#getAlternative <em>Alternative</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Alternative</em>'.
	 * @see tools.descartes.dni.dnimm3ap.AlternativeDependencySet#getAlternative()
	 * @see #getAlternativeDependencySet()
	 * @generated
	 */
	EReference getAlternativeDependencySet_Alternative();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dni.dnimm3ap.AdaptableDependency <em>Adaptable Dependency</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Adaptable Dependency</em>'.
	 * @see tools.descartes.dni.dnimm3ap.AdaptableDependency
	 * @generated
	 */
	EClass getAdaptableDependency();

	/**
	 * Returns the meta object for the containment reference '{@link tools.descartes.dni.dnimm3ap.AdaptableDependency#getParameter <em>Parameter</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Parameter</em>'.
	 * @see tools.descartes.dni.dnimm3ap.AdaptableDependency#getParameter()
	 * @see #getAdaptableDependency()
	 * @generated
	 */
	EReference getAdaptableDependency_Parameter();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dni.dnimm3ap.AlternativeVariable <em>Alternative Variable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Alternative Variable</em>'.
	 * @see tools.descartes.dni.dnimm3ap.AlternativeVariable
	 * @generated
	 */
	EClass getAlternativeVariable();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dni.dnimm3ap.AlternativeVariableSet <em>Alternative Variable Set</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Alternative Variable Set</em>'.
	 * @see tools.descartes.dni.dnimm3ap.AlternativeVariableSet
	 * @generated
	 */
	EClass getAlternativeVariableSet();

	/**
	 * Returns the meta object for the containment reference list '{@link tools.descartes.dni.dnimm3ap.AlternativeVariableSet#getAlternative <em>Alternative</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Alternative</em>'.
	 * @see tools.descartes.dni.dnimm3ap.AlternativeVariableSet#getAlternative()
	 * @see #getAlternativeVariableSet()
	 * @generated
	 */
	EReference getAlternativeVariableSet_Alternative();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dni.dnimm3ap.AdaptableVariable <em>Adaptable Variable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Adaptable Variable</em>'.
	 * @see tools.descartes.dni.dnimm3ap.AdaptableVariable
	 * @generated
	 */
	EClass getAdaptableVariable();

	/**
	 * Returns the meta object for the containment reference '{@link tools.descartes.dni.dnimm3ap.AdaptableVariable#getParameter <em>Parameter</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Parameter</em>'.
	 * @see tools.descartes.dni.dnimm3ap.AdaptableVariable#getParameter()
	 * @see #getAdaptableVariable()
	 * @generated
	 */
	EReference getAdaptableVariable_Parameter();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dni.dnimm3ap.ICostable <em>ICostable</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>ICostable</em>'.
	 * @see tools.descartes.dni.dnimm3ap.ICostable
	 * @generated
	 */
	EClass getICostable();

	/**
	 * Returns the meta object for the containment reference list '{@link tools.descartes.dni.dnimm3ap.ICostable#getCost <em>Cost</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference list '<em>Cost</em>'.
	 * @see tools.descartes.dni.dnimm3ap.ICostable#getCost()
	 * @see #getICostable()
	 * @generated
	 */
	EReference getICostable_Cost();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dni.dnimm3ap.Cost <em>Cost</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Cost</em>'.
	 * @see tools.descartes.dni.dnimm3ap.Cost
	 * @generated
	 */
	EClass getCost();

	/**
	 * Returns the meta object for the containment reference '{@link tools.descartes.dni.dnimm3ap.Cost#getCostFunction <em>Cost Function</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the containment reference '<em>Cost Function</em>'.
	 * @see tools.descartes.dni.dnimm3ap.Cost#getCostFunction()
	 * @see #getCost()
	 * @generated
	 */
	EReference getCost_CostFunction();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dni.dnimm3ap.Investment <em>Investment</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Investment</em>'.
	 * @see tools.descartes.dni.dnimm3ap.Investment
	 * @generated
	 */
	EClass getInvestment();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dni.dnimm3ap.HandlingTime <em>Handling Time</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Handling Time</em>'.
	 * @see tools.descartes.dni.dnimm3ap.HandlingTime
	 * @generated
	 */
	EClass getHandlingTime();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dni.dnimm3ap.ICostFunction <em>ICost Function</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>ICost Function</em>'.
	 * @see tools.descartes.dni.dnimm3ap.ICostFunction
	 * @generated
	 */
	EClass getICostFunction();

	/**
	 * Returns the meta object for class '{@link tools.descartes.dni.dnimm3ap.FixedCostFunction <em>Fixed Cost Function</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for class '<em>Fixed Cost Function</em>'.
	 * @see tools.descartes.dni.dnimm3ap.FixedCostFunction
	 * @generated
	 */
	EClass getFixedCostFunction();

	/**
	 * Returns the meta object for the attribute '{@link tools.descartes.dni.dnimm3ap.FixedCostFunction#getValue <em>Value</em>}'.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the meta object for the attribute '<em>Value</em>'.
	 * @see tools.descartes.dni.dnimm3ap.FixedCostFunction#getValue()
	 * @see #getFixedCostFunction()
	 * @generated
	 */
	EAttribute getFixedCostFunction_Value();

	/**
	 * Returns the factory that creates the instances of the model.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @return the factory that creates the instances of the model.
	 * @generated
	 */
	DNIAPFactory getDNIAPFactory();

	/**
	 * <!-- begin-user-doc -->
	 * Defines literals for the meta objects that represent
	 * <ul>
	 *   <li>each class,</li>
	 *   <li>each feature of each class,</li>
	 *   <li>each operation of each class,</li>
	 *   <li>each enum,</li>
	 *   <li>and each data type</li>
	 * </ul>
	 * <!-- end-user-doc -->
	 * @generated
	 */
	interface Literals {
		/**
		 * The meta object literal for the '{@link tools.descartes.dni.dnimm3ap.impl.AdaptationPointsImpl <em>Adaptation Points</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dni.dnimm3ap.impl.AdaptationPointsImpl
		 * @see tools.descartes.dni.dnimm3ap.impl.DNIAPPackageImpl#getAdaptationPoints()
		 * @generated
		 */
		EClass ADAPTATION_POINTS = eINSTANCE.getAdaptationPoints();

		/**
		 * The meta object literal for the '<em><b>Repositories</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ADAPTATION_POINTS__REPOSITORIES = eINSTANCE.getAdaptationPoints_Repositories();

		/**
		 * The meta object literal for the '<em><b>Groups</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ADAPTATION_POINTS__GROUPS = eINSTANCE.getAdaptationPoints_Groups();

		/**
		 * The meta object literal for the '<em><b>Network Infrastructure</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ADAPTATION_POINTS__NETWORK_INFRASTRUCTURE = eINSTANCE.getAdaptationPoints_NetworkInfrastructure();

		/**
		 * The meta object literal for the '{@link tools.descartes.dni.dnimm3ap.impl.AdaptationRepositoryImpl <em>Adaptation Repository</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dni.dnimm3ap.impl.AdaptationRepositoryImpl
		 * @see tools.descartes.dni.dnimm3ap.impl.DNIAPPackageImpl#getAdaptationRepository()
		 * @generated
		 */
		EClass ADAPTATION_REPOSITORY = eINSTANCE.getAdaptationRepository();

		/**
		 * The meta object literal for the '<em><b>Nodes</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ADAPTATION_REPOSITORY__NODES = eINSTANCE.getAdaptationRepository_Nodes();

		/**
		 * The meta object literal for the '<em><b>End Performances</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ADAPTATION_REPOSITORY__END_PERFORMANCES = eINSTANCE.getAdaptationRepository_EndPerformances();

		/**
		 * The meta object literal for the '<em><b>Intermediate Performances</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ADAPTATION_REPOSITORY__INTERMEDIATE_PERFORMANCES = eINSTANCE.getAdaptationRepository_IntermediatePerformances();

		/**
		 * The meta object literal for the '<em><b>Sdn Node Performances</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ADAPTATION_REPOSITORY__SDN_NODE_PERFORMANCES = eINSTANCE.getAdaptationRepository_SdnNodePerformances();

		/**
		 * The meta object literal for the '<em><b>Network Interfaces</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ADAPTATION_REPOSITORY__NETWORK_INTERFACES = eINSTANCE.getAdaptationRepository_NetworkInterfaces();

		/**
		 * The meta object literal for the '<em><b>Network Interface Performances</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ADAPTATION_REPOSITORY__NETWORK_INTERFACE_PERFORMANCES = eINSTANCE.getAdaptationRepository_NetworkInterfacePerformances();

		/**
		 * The meta object literal for the '<em><b>Links</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ADAPTATION_REPOSITORY__LINKS = eINSTANCE.getAdaptationRepository_Links();

		/**
		 * The meta object literal for the '<em><b>Link Performances</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ADAPTATION_REPOSITORY__LINK_PERFORMANCES = eINSTANCE.getAdaptationRepository_LinkPerformances();

		/**
		 * The meta object literal for the '{@link tools.descartes.dni.dnimm3ap.IAdaptableEntity <em>IAdaptable Entity</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dni.dnimm3ap.IAdaptableEntity
		 * @see tools.descartes.dni.dnimm3ap.impl.DNIAPPackageImpl#getIAdaptableEntity()
		 * @generated
		 */
		EClass IADAPTABLE_ENTITY = eINSTANCE.getIAdaptableEntity();

		/**
		 * The meta object literal for the '<em><b>Entity Type</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference IADAPTABLE_ENTITY__ENTITY_TYPE = eINSTANCE.getIAdaptableEntity_EntityType();

		/**
		 * The meta object literal for the '{@link tools.descartes.dni.dnimm3ap.IAdaptableGroupableEntity <em>IAdaptable Groupable Entity</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dni.dnimm3ap.IAdaptableGroupableEntity
		 * @see tools.descartes.dni.dnimm3ap.impl.DNIAPPackageImpl#getIAdaptableGroupableEntity()
		 * @generated
		 */
		EClass IADAPTABLE_GROUPABLE_ENTITY = eINSTANCE.getIAdaptableGroupableEntity();

		/**
		 * The meta object literal for the '{@link tools.descartes.dni.dnimm3ap.impl.AdaptableNodeImpl <em>Adaptable Node</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dni.dnimm3ap.impl.AdaptableNodeImpl
		 * @see tools.descartes.dni.dnimm3ap.impl.DNIAPPackageImpl#getAdaptableNode()
		 * @generated
		 */
		EClass ADAPTABLE_NODE = eINSTANCE.getAdaptableNode();

		/**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute ADAPTABLE_NODE__NAME = eINSTANCE.getAdaptableNode_Name();

		/**
		 * The meta object literal for the '<em><b>End Performance</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ADAPTABLE_NODE__END_PERFORMANCE = eINSTANCE.getAdaptableNode_EndPerformance();

		/**
		 * The meta object literal for the '<em><b>Intermediate Performance</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ADAPTABLE_NODE__INTERMEDIATE_PERFORMANCE = eINSTANCE.getAdaptableNode_IntermediatePerformance();

		/**
		 * The meta object literal for the '<em><b>Sdn Node Performance</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ADAPTABLE_NODE__SDN_NODE_PERFORMANCE = eINSTANCE.getAdaptableNode_SdnNodePerformance();

		/**
		 * The meta object literal for the '<em><b>Network Interface</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ADAPTABLE_NODE__NETWORK_INTERFACE = eINSTANCE.getAdaptableNode_NetworkInterface();

		/**
		 * The meta object literal for the '<em><b>Adaptation Group</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ADAPTABLE_NODE__ADAPTATION_GROUP = eINSTANCE.getAdaptableNode_AdaptationGroup();

		/**
		 * The meta object literal for the '{@link tools.descartes.dni.dnimm3ap.impl.AdaptableLinkImpl <em>Adaptable Link</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dni.dnimm3ap.impl.AdaptableLinkImpl
		 * @see tools.descartes.dni.dnimm3ap.impl.DNIAPPackageImpl#getAdaptableLink()
		 * @generated
		 */
		EClass ADAPTABLE_LINK = eINSTANCE.getAdaptableLink();

		/**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute ADAPTABLE_LINK__NAME = eINSTANCE.getAdaptableLink_Name();

		/**
		 * The meta object literal for the '<em><b>Link Performance</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ADAPTABLE_LINK__LINK_PERFORMANCE = eINSTANCE.getAdaptableLink_LinkPerformance();

		/**
		 * The meta object literal for the '<em><b>Network Interface</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ADAPTABLE_LINK__NETWORK_INTERFACE = eINSTANCE.getAdaptableLink_NetworkInterface();

		/**
		 * The meta object literal for the '<em><b>Adaptation Group</b></em>' reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ADAPTABLE_LINK__ADAPTATION_GROUP = eINSTANCE.getAdaptableLink_AdaptationGroup();

		/**
		 * The meta object literal for the '{@link tools.descartes.dni.dnimm3ap.impl.AdaptableLinkPerformanceImpl <em>Adaptable Link Performance</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dni.dnimm3ap.impl.AdaptableLinkPerformanceImpl
		 * @see tools.descartes.dni.dnimm3ap.impl.DNIAPPackageImpl#getAdaptableLinkPerformance()
		 * @generated
		 */
		EClass ADAPTABLE_LINK_PERFORMANCE = eINSTANCE.getAdaptableLinkPerformance();

		/**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute ADAPTABLE_LINK_PERFORMANCE__NAME = eINSTANCE.getAdaptableLinkPerformance_Name();

		/**
		 * The meta object literal for the '<em><b>Propagation Delay</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ADAPTABLE_LINK_PERFORMANCE__PROPAGATION_DELAY = eINSTANCE.getAdaptableLinkPerformance_PropagationDelay();

		/**
		 * The meta object literal for the '<em><b>Maximal Supported Bandwidth</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ADAPTABLE_LINK_PERFORMANCE__MAXIMAL_SUPPORTED_BANDWIDTH = eINSTANCE.getAdaptableLinkPerformance_MaximalSupportedBandwidth();

		/**
		 * The meta object literal for the '{@link tools.descartes.dni.dnimm3ap.impl.AdaptableEndPerformanceImpl <em>Adaptable End Performance</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dni.dnimm3ap.impl.AdaptableEndPerformanceImpl
		 * @see tools.descartes.dni.dnimm3ap.impl.DNIAPPackageImpl#getAdaptableEndPerformance()
		 * @generated
		 */
		EClass ADAPTABLE_END_PERFORMANCE = eINSTANCE.getAdaptableEndPerformance();

		/**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute ADAPTABLE_END_PERFORMANCE__NAME = eINSTANCE.getAdaptableEndPerformance_Name();

		/**
		 * The meta object literal for the '<em><b>Software Layers Delay</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ADAPTABLE_END_PERFORMANCE__SOFTWARE_LAYERS_DELAY = eINSTANCE.getAdaptableEndPerformance_SoftwareLayersDelay();

		/**
		 * The meta object literal for the '{@link tools.descartes.dni.dnimm3ap.impl.AdaptableIntermediatePerformanceImpl <em>Adaptable Intermediate Performance</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dni.dnimm3ap.impl.AdaptableIntermediatePerformanceImpl
		 * @see tools.descartes.dni.dnimm3ap.impl.DNIAPPackageImpl#getAdaptableIntermediatePerformance()
		 * @generated
		 */
		EClass ADAPTABLE_INTERMEDIATE_PERFORMANCE = eINSTANCE.getAdaptableIntermediatePerformance();

		/**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute ADAPTABLE_INTERMEDIATE_PERFORMANCE__NAME = eINSTANCE.getAdaptableIntermediatePerformance_Name();

		/**
		 * The meta object literal for the '<em><b>Forwarding Latency</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ADAPTABLE_INTERMEDIATE_PERFORMANCE__FORWARDING_LATENCY = eINSTANCE.getAdaptableIntermediatePerformance_ForwardingLatency();

		/**
		 * The meta object literal for the '<em><b>Forwarding Bandwidth BPS</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ADAPTABLE_INTERMEDIATE_PERFORMANCE__FORWARDING_BANDWIDTH_BPS = eINSTANCE.getAdaptableIntermediatePerformance_ForwardingBandwidthBPS();

		/**
		 * The meta object literal for the '<em><b>Switching Capacity PPS</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ADAPTABLE_INTERMEDIATE_PERFORMANCE__SWITCHING_CAPACITY_PPS = eINSTANCE.getAdaptableIntermediatePerformance_SwitchingCapacityPPS();

		/**
		 * The meta object literal for the '{@link tools.descartes.dni.dnimm3ap.impl.AdaptableSdnNodePerformanceImpl <em>Adaptable Sdn Node Performance</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dni.dnimm3ap.impl.AdaptableSdnNodePerformanceImpl
		 * @see tools.descartes.dni.dnimm3ap.impl.DNIAPPackageImpl#getAdaptableSdnNodePerformance()
		 * @generated
		 */
		EClass ADAPTABLE_SDN_NODE_PERFORMANCE = eINSTANCE.getAdaptableSdnNodePerformance();

		/**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute ADAPTABLE_SDN_NODE_PERFORMANCE__NAME = eINSTANCE.getAdaptableSdnNodePerformance_Name();

		/**
		 * The meta object literal for the '<em><b>Software Switching Performance</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ADAPTABLE_SDN_NODE_PERFORMANCE__SOFTWARE_SWITCHING_PERFORMANCE = eINSTANCE.getAdaptableSdnNodePerformance_SoftwareSwitchingPerformance();

		/**
		 * The meta object literal for the '<em><b>Hardware Switching Performance</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ADAPTABLE_SDN_NODE_PERFORMANCE__HARDWARE_SWITCHING_PERFORMANCE = eINSTANCE.getAdaptableSdnNodePerformance_HardwareSwitchingPerformance();

		/**
		 * The meta object literal for the '{@link tools.descartes.dni.dnimm3ap.impl.AdaptableNetworkInterfaceImpl <em>Adaptable Network Interface</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dni.dnimm3ap.impl.AdaptableNetworkInterfaceImpl
		 * @see tools.descartes.dni.dnimm3ap.impl.DNIAPPackageImpl#getAdaptableNetworkInterface()
		 * @generated
		 */
		EClass ADAPTABLE_NETWORK_INTERFACE = eINSTANCE.getAdaptableNetworkInterface();

		/**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute ADAPTABLE_NETWORK_INTERFACE__NAME = eINSTANCE.getAdaptableNetworkInterface_Name();

		/**
		 * The meta object literal for the '<em><b>Network Interface Performance</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ADAPTABLE_NETWORK_INTERFACE__NETWORK_INTERFACE_PERFORMANCE = eINSTANCE.getAdaptableNetworkInterface_NetworkInterfacePerformance();

		/**
		 * The meta object literal for the '{@link tools.descartes.dni.dnimm3ap.impl.AdaptableNetworkInterfacePerformanceImpl <em>Adaptable Network Interface Performance</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dni.dnimm3ap.impl.AdaptableNetworkInterfacePerformanceImpl
		 * @see tools.descartes.dni.dnimm3ap.impl.DNIAPPackageImpl#getAdaptableNetworkInterfacePerformance()
		 * @generated
		 */
		EClass ADAPTABLE_NETWORK_INTERFACE_PERFORMANCE = eINSTANCE.getAdaptableNetworkInterfacePerformance();

		/**
		 * The meta object literal for the '<em><b>Name</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute ADAPTABLE_NETWORK_INTERFACE_PERFORMANCE__NAME = eINSTANCE.getAdaptableNetworkInterfacePerformance_Name();

		/**
		 * The meta object literal for the '<em><b>Packet Processing Time</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ADAPTABLE_NETWORK_INTERFACE_PERFORMANCE__PACKET_PROCESSING_TIME = eINSTANCE.getAdaptableNetworkInterfacePerformance_PacketProcessingTime();

		/**
		 * The meta object literal for the '<em><b>Interface Throughput</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ADAPTABLE_NETWORK_INTERFACE_PERFORMANCE__INTERFACE_THROUGHPUT = eINSTANCE.getAdaptableNetworkInterfacePerformance_InterfaceThroughput();

		/**
		 * The meta object literal for the '{@link tools.descartes.dni.dnimm3ap.impl.AdaptationGroupsImpl <em>Adaptation Groups</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dni.dnimm3ap.impl.AdaptationGroupsImpl
		 * @see tools.descartes.dni.dnimm3ap.impl.DNIAPPackageImpl#getAdaptationGroups()
		 * @generated
		 */
		EClass ADAPTATION_GROUPS = eINSTANCE.getAdaptationGroups();

		/**
		 * The meta object literal for the '<em><b>Nodes</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ADAPTATION_GROUPS__NODES = eINSTANCE.getAdaptationGroups_Nodes();

		/**
		 * The meta object literal for the '<em><b>Links</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ADAPTATION_GROUPS__LINKS = eINSTANCE.getAdaptationGroups_Links();

		/**
		 * The meta object literal for the '{@link tools.descartes.dni.dnimm3ap.IAdaptationGroup <em>IAdaptation Group</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dni.dnimm3ap.IAdaptationGroup
		 * @see tools.descartes.dni.dnimm3ap.impl.DNIAPPackageImpl#getIAdaptationGroup()
		 * @generated
		 */
		EClass IADAPTATION_GROUP = eINSTANCE.getIAdaptationGroup();

		/**
		 * The meta object literal for the '{@link tools.descartes.dni.dnimm3ap.impl.NodeAdaptationGroupImpl <em>Node Adaptation Group</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dni.dnimm3ap.impl.NodeAdaptationGroupImpl
		 * @see tools.descartes.dni.dnimm3ap.impl.DNIAPPackageImpl#getNodeAdaptationGroup()
		 * @generated
		 */
		EClass NODE_ADAPTATION_GROUP = eINSTANCE.getNodeAdaptationGroup();

		/**
		 * The meta object literal for the '<em><b>Items</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference NODE_ADAPTATION_GROUP__ITEMS = eINSTANCE.getNodeAdaptationGroup_Items();

		/**
		 * The meta object literal for the '{@link tools.descartes.dni.dnimm3ap.impl.LinkAdaptationGroupImpl <em>Link Adaptation Group</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dni.dnimm3ap.impl.LinkAdaptationGroupImpl
		 * @see tools.descartes.dni.dnimm3ap.impl.DNIAPPackageImpl#getLinkAdaptationGroup()
		 * @generated
		 */
		EClass LINK_ADAPTATION_GROUP = eINSTANCE.getLinkAdaptationGroup();

		/**
		 * The meta object literal for the '<em><b>Items</b></em>' reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference LINK_ADAPTATION_GROUP__ITEMS = eINSTANCE.getLinkAdaptationGroup_Items();

		/**
		 * The meta object literal for the '{@link tools.descartes.dni.dnimm3ap.AlternativeDependency <em>Alternative Dependency</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dni.dnimm3ap.AlternativeDependency
		 * @see tools.descartes.dni.dnimm3ap.impl.DNIAPPackageImpl#getAlternativeDependency()
		 * @generated
		 */
		EClass ALTERNATIVE_DEPENDENCY = eINSTANCE.getAlternativeDependency();

		/**
		 * The meta object literal for the '{@link tools.descartes.dni.dnimm3ap.impl.AlternativeDependencySetImpl <em>Alternative Dependency Set</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dni.dnimm3ap.impl.AlternativeDependencySetImpl
		 * @see tools.descartes.dni.dnimm3ap.impl.DNIAPPackageImpl#getAlternativeDependencySet()
		 * @generated
		 */
		EClass ALTERNATIVE_DEPENDENCY_SET = eINSTANCE.getAlternativeDependencySet();

		/**
		 * The meta object literal for the '<em><b>Alternative</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ALTERNATIVE_DEPENDENCY_SET__ALTERNATIVE = eINSTANCE.getAlternativeDependencySet_Alternative();

		/**
		 * The meta object literal for the '{@link tools.descartes.dni.dnimm3ap.impl.AdaptableDependencyImpl <em>Adaptable Dependency</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dni.dnimm3ap.impl.AdaptableDependencyImpl
		 * @see tools.descartes.dni.dnimm3ap.impl.DNIAPPackageImpl#getAdaptableDependency()
		 * @generated
		 */
		EClass ADAPTABLE_DEPENDENCY = eINSTANCE.getAdaptableDependency();

		/**
		 * The meta object literal for the '<em><b>Parameter</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ADAPTABLE_DEPENDENCY__PARAMETER = eINSTANCE.getAdaptableDependency_Parameter();

		/**
		 * The meta object literal for the '{@link tools.descartes.dni.dnimm3ap.AlternativeVariable <em>Alternative Variable</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dni.dnimm3ap.AlternativeVariable
		 * @see tools.descartes.dni.dnimm3ap.impl.DNIAPPackageImpl#getAlternativeVariable()
		 * @generated
		 */
		EClass ALTERNATIVE_VARIABLE = eINSTANCE.getAlternativeVariable();

		/**
		 * The meta object literal for the '{@link tools.descartes.dni.dnimm3ap.impl.AlternativeVariableSetImpl <em>Alternative Variable Set</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dni.dnimm3ap.impl.AlternativeVariableSetImpl
		 * @see tools.descartes.dni.dnimm3ap.impl.DNIAPPackageImpl#getAlternativeVariableSet()
		 * @generated
		 */
		EClass ALTERNATIVE_VARIABLE_SET = eINSTANCE.getAlternativeVariableSet();

		/**
		 * The meta object literal for the '<em><b>Alternative</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ALTERNATIVE_VARIABLE_SET__ALTERNATIVE = eINSTANCE.getAlternativeVariableSet_Alternative();

		/**
		 * The meta object literal for the '{@link tools.descartes.dni.dnimm3ap.impl.AdaptableVariableImpl <em>Adaptable Variable</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dni.dnimm3ap.impl.AdaptableVariableImpl
		 * @see tools.descartes.dni.dnimm3ap.impl.DNIAPPackageImpl#getAdaptableVariable()
		 * @generated
		 */
		EClass ADAPTABLE_VARIABLE = eINSTANCE.getAdaptableVariable();

		/**
		 * The meta object literal for the '<em><b>Parameter</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ADAPTABLE_VARIABLE__PARAMETER = eINSTANCE.getAdaptableVariable_Parameter();

		/**
		 * The meta object literal for the '{@link tools.descartes.dni.dnimm3ap.ICostable <em>ICostable</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dni.dnimm3ap.ICostable
		 * @see tools.descartes.dni.dnimm3ap.impl.DNIAPPackageImpl#getICostable()
		 * @generated
		 */
		EClass ICOSTABLE = eINSTANCE.getICostable();

		/**
		 * The meta object literal for the '<em><b>Cost</b></em>' containment reference list feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference ICOSTABLE__COST = eINSTANCE.getICostable_Cost();

		/**
		 * The meta object literal for the '{@link tools.descartes.dni.dnimm3ap.impl.CostImpl <em>Cost</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dni.dnimm3ap.impl.CostImpl
		 * @see tools.descartes.dni.dnimm3ap.impl.DNIAPPackageImpl#getCost()
		 * @generated
		 */
		EClass COST = eINSTANCE.getCost();

		/**
		 * The meta object literal for the '<em><b>Cost Function</b></em>' containment reference feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EReference COST__COST_FUNCTION = eINSTANCE.getCost_CostFunction();

		/**
		 * The meta object literal for the '{@link tools.descartes.dni.dnimm3ap.impl.InvestmentImpl <em>Investment</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dni.dnimm3ap.impl.InvestmentImpl
		 * @see tools.descartes.dni.dnimm3ap.impl.DNIAPPackageImpl#getInvestment()
		 * @generated
		 */
		EClass INVESTMENT = eINSTANCE.getInvestment();

		/**
		 * The meta object literal for the '{@link tools.descartes.dni.dnimm3ap.impl.HandlingTimeImpl <em>Handling Time</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dni.dnimm3ap.impl.HandlingTimeImpl
		 * @see tools.descartes.dni.dnimm3ap.impl.DNIAPPackageImpl#getHandlingTime()
		 * @generated
		 */
		EClass HANDLING_TIME = eINSTANCE.getHandlingTime();

		/**
		 * The meta object literal for the '{@link tools.descartes.dni.dnimm3ap.ICostFunction <em>ICost Function</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dni.dnimm3ap.ICostFunction
		 * @see tools.descartes.dni.dnimm3ap.impl.DNIAPPackageImpl#getICostFunction()
		 * @generated
		 */
		EClass ICOST_FUNCTION = eINSTANCE.getICostFunction();

		/**
		 * The meta object literal for the '{@link tools.descartes.dni.dnimm3ap.impl.FixedCostFunctionImpl <em>Fixed Cost Function</em>}' class.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @see tools.descartes.dni.dnimm3ap.impl.FixedCostFunctionImpl
		 * @see tools.descartes.dni.dnimm3ap.impl.DNIAPPackageImpl#getFixedCostFunction()
		 * @generated
		 */
		EClass FIXED_COST_FUNCTION = eINSTANCE.getFixedCostFunction();

		/**
		 * The meta object literal for the '<em><b>Value</b></em>' attribute feature.
		 * <!-- begin-user-doc -->
		 * <!-- end-user-doc -->
		 * @generated
		 */
		EAttribute FIXED_COST_FUNCTION__VALUE = eINSTANCE.getFixedCostFunction_Value();

	}

} //DNIAPPackage
