/**
 */
package tools.descartes.dni.dnimm3ap.impl;

import org.eclipse.emf.ecore.EClass;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EPackage;

import org.eclipse.emf.ecore.impl.EFactoryImpl;

import org.eclipse.emf.ecore.plugin.EcorePlugin;

import tools.descartes.dni.dnimm3ap.*;

/**
 * <!-- begin-user-doc -->
 * An implementation of the model <b>Factory</b>.
 * <!-- end-user-doc -->
 * @generated
 */
public class DNIAPFactoryImpl extends EFactoryImpl implements DNIAPFactory {
	/**
	 * Creates the default factory implementation.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public static DNIAPFactory init() {
		try {
			DNIAPFactory theDNIAPFactory = (DNIAPFactory)EPackage.Registry.INSTANCE.getEFactory(DNIAPPackage.eNS_URI);
			if (theDNIAPFactory != null) {
				return theDNIAPFactory;
			}
		}
		catch (Exception exception) {
			EcorePlugin.INSTANCE.log(exception);
		}
		return new DNIAPFactoryImpl();
	}

	/**
	 * Creates an instance of the factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public DNIAPFactoryImpl() {
		super();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public EObject create(EClass eClass) {
		switch (eClass.getClassifierID()) {
			case DNIAPPackage.ADAPTATION_POINTS: return createAdaptationPoints();
			case DNIAPPackage.ADAPTATION_REPOSITORY: return createAdaptationRepository();
			case DNIAPPackage.ADAPTABLE_NODE: return createAdaptableNode();
			case DNIAPPackage.ADAPTABLE_LINK: return createAdaptableLink();
			case DNIAPPackage.ADAPTABLE_LINK_PERFORMANCE: return createAdaptableLinkPerformance();
			case DNIAPPackage.ADAPTABLE_END_PERFORMANCE: return createAdaptableEndPerformance();
			case DNIAPPackage.ADAPTABLE_INTERMEDIATE_PERFORMANCE: return createAdaptableIntermediatePerformance();
			case DNIAPPackage.ADAPTABLE_SDN_NODE_PERFORMANCE: return createAdaptableSdnNodePerformance();
			case DNIAPPackage.ADAPTABLE_NETWORK_INTERFACE: return createAdaptableNetworkInterface();
			case DNIAPPackage.ADAPTABLE_NETWORK_INTERFACE_PERFORMANCE: return createAdaptableNetworkInterfacePerformance();
			case DNIAPPackage.ADAPTATION_GROUPS: return createAdaptationGroups();
			case DNIAPPackage.NODE_ADAPTATION_GROUP: return createNodeAdaptationGroup();
			case DNIAPPackage.LINK_ADAPTATION_GROUP: return createLinkAdaptationGroup();
			case DNIAPPackage.ALTERNATIVE_DEPENDENCY_SET: return createAlternativeDependencySet();
			case DNIAPPackage.ADAPTABLE_DEPENDENCY: return createAdaptableDependency();
			case DNIAPPackage.ALTERNATIVE_VARIABLE_SET: return createAlternativeVariableSet();
			case DNIAPPackage.ADAPTABLE_VARIABLE: return createAdaptableVariable();
			case DNIAPPackage.INVESTMENT: return createInvestment();
			case DNIAPPackage.HANDLING_TIME: return createHandlingTime();
			case DNIAPPackage.FIXED_COST_FUNCTION: return createFixedCostFunction();
			default:
				throw new IllegalArgumentException("The class '" + eClass.getName() + "' is not a valid classifier");
		}
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public AdaptationPoints createAdaptationPoints() {
		AdaptationPointsImpl adaptationPoints = new AdaptationPointsImpl();
		return adaptationPoints;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public AdaptationRepository createAdaptationRepository() {
		AdaptationRepositoryImpl adaptationRepository = new AdaptationRepositoryImpl();
		return adaptationRepository;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public AdaptableNode createAdaptableNode() {
		AdaptableNodeImpl adaptableNode = new AdaptableNodeImpl();
		return adaptableNode;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public AdaptableLink createAdaptableLink() {
		AdaptableLinkImpl adaptableLink = new AdaptableLinkImpl();
		return adaptableLink;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public AdaptableLinkPerformance createAdaptableLinkPerformance() {
		AdaptableLinkPerformanceImpl adaptableLinkPerformance = new AdaptableLinkPerformanceImpl();
		return adaptableLinkPerformance;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public AdaptableEndPerformance createAdaptableEndPerformance() {
		AdaptableEndPerformanceImpl adaptableEndPerformance = new AdaptableEndPerformanceImpl();
		return adaptableEndPerformance;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public AdaptableIntermediatePerformance createAdaptableIntermediatePerformance() {
		AdaptableIntermediatePerformanceImpl adaptableIntermediatePerformance = new AdaptableIntermediatePerformanceImpl();
		return adaptableIntermediatePerformance;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public AdaptableSdnNodePerformance createAdaptableSdnNodePerformance() {
		AdaptableSdnNodePerformanceImpl adaptableSdnNodePerformance = new AdaptableSdnNodePerformanceImpl();
		return adaptableSdnNodePerformance;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public AdaptableNetworkInterface createAdaptableNetworkInterface() {
		AdaptableNetworkInterfaceImpl adaptableNetworkInterface = new AdaptableNetworkInterfaceImpl();
		return adaptableNetworkInterface;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public AdaptableNetworkInterfacePerformance createAdaptableNetworkInterfacePerformance() {
		AdaptableNetworkInterfacePerformanceImpl adaptableNetworkInterfacePerformance = new AdaptableNetworkInterfacePerformanceImpl();
		return adaptableNetworkInterfacePerformance;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public AdaptationGroups createAdaptationGroups() {
		AdaptationGroupsImpl adaptationGroups = new AdaptationGroupsImpl();
		return adaptationGroups;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public NodeAdaptationGroup createNodeAdaptationGroup() {
		NodeAdaptationGroupImpl nodeAdaptationGroup = new NodeAdaptationGroupImpl();
		return nodeAdaptationGroup;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public LinkAdaptationGroup createLinkAdaptationGroup() {
		LinkAdaptationGroupImpl linkAdaptationGroup = new LinkAdaptationGroupImpl();
		return linkAdaptationGroup;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public AlternativeDependencySet createAlternativeDependencySet() {
		AlternativeDependencySetImpl alternativeDependencySet = new AlternativeDependencySetImpl();
		return alternativeDependencySet;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public AdaptableDependency createAdaptableDependency() {
		AdaptableDependencyImpl adaptableDependency = new AdaptableDependencyImpl();
		return adaptableDependency;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public AlternativeVariableSet createAlternativeVariableSet() {
		AlternativeVariableSetImpl alternativeVariableSet = new AlternativeVariableSetImpl();
		return alternativeVariableSet;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public AdaptableVariable createAdaptableVariable() {
		AdaptableVariableImpl adaptableVariable = new AdaptableVariableImpl();
		return adaptableVariable;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public Investment createInvestment() {
		InvestmentImpl investment = new InvestmentImpl();
		return investment;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public HandlingTime createHandlingTime() {
		HandlingTimeImpl handlingTime = new HandlingTimeImpl();
		return handlingTime;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public FixedCostFunction createFixedCostFunction() {
		FixedCostFunctionImpl fixedCostFunction = new FixedCostFunctionImpl();
		return fixedCostFunction;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public DNIAPPackage getDNIAPPackage() {
		return (DNIAPPackage)getEPackage();
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @deprecated
	 * @generated
	 */
	@Deprecated
	public static DNIAPPackage getPackage() {
		return DNIAPPackage.eINSTANCE;
	}

} //DNIAPFactoryImpl
