/**
 */
package tools.descartes.dni.dnimm3ap.provider;

import java.util.ArrayList;
import java.util.Collection;

import org.eclipse.emf.common.notify.Adapter;
import org.eclipse.emf.common.notify.Notification;
import org.eclipse.emf.common.notify.Notifier;

import org.eclipse.emf.edit.provider.ChangeNotifier;
import org.eclipse.emf.edit.provider.ComposeableAdapterFactory;
import org.eclipse.emf.edit.provider.ComposedAdapterFactory;
import org.eclipse.emf.edit.provider.IChangeNotifier;
import org.eclipse.emf.edit.provider.IDisposable;
import org.eclipse.emf.edit.provider.IEditingDomainItemProvider;
import org.eclipse.emf.edit.provider.IItemLabelProvider;
import org.eclipse.emf.edit.provider.IItemPropertySource;
import org.eclipse.emf.edit.provider.INotifyChangedListener;
import org.eclipse.emf.edit.provider.IStructuredItemContentProvider;
import org.eclipse.emf.edit.provider.ITreeItemContentProvider;

import tools.descartes.dni.dnimm3ap.util.DNIAPAdapterFactory;

/**
 * This is the factory that is used to provide the interfaces needed to support Viewers.
 * The adapters generated by this factory convert EMF adapter notifications into calls to {@link #fireNotifyChanged fireNotifyChanged}.
 * The adapters also support Eclipse property sheets.
 * Note that most of the adapters are shared among multiple instances.
 * <!-- begin-user-doc -->
 * <!-- end-user-doc -->
 * @generated
 */
public class DNIAPItemProviderAdapterFactory extends DNIAPAdapterFactory implements ComposeableAdapterFactory, IChangeNotifier, IDisposable {
	/**
	 * This keeps track of the root adapter factory that delegates to this adapter factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected ComposedAdapterFactory parentAdapterFactory;

	/**
	 * This is used to implement {@link org.eclipse.emf.edit.provider.IChangeNotifier}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected IChangeNotifier changeNotifier = new ChangeNotifier();

	/**
	 * This keeps track of all the supported types checked by {@link #isFactoryForType isFactoryForType}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected Collection<Object> supportedTypes = new ArrayList<Object>();

	/**
	 * This constructs an instance.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public DNIAPItemProviderAdapterFactory() {
		supportedTypes.add(IEditingDomainItemProvider.class);
		supportedTypes.add(IStructuredItemContentProvider.class);
		supportedTypes.add(ITreeItemContentProvider.class);
		supportedTypes.add(IItemLabelProvider.class);
		supportedTypes.add(IItemPropertySource.class);
	}

	/**
	 * This keeps track of the one adapter used for all {@link tools.descartes.dni.dnimm3ap.AdaptationPoints} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected AdaptationPointsItemProvider adaptationPointsItemProvider;

	/**
	 * This creates an adapter for a {@link tools.descartes.dni.dnimm3ap.AdaptationPoints}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createAdaptationPointsAdapter() {
		if (adaptationPointsItemProvider == null) {
			adaptationPointsItemProvider = new AdaptationPointsItemProvider(this);
		}

		return adaptationPointsItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link tools.descartes.dni.dnimm3ap.AdaptationRepository} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected AdaptationRepositoryItemProvider adaptationRepositoryItemProvider;

	/**
	 * This creates an adapter for a {@link tools.descartes.dni.dnimm3ap.AdaptationRepository}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createAdaptationRepositoryAdapter() {
		if (adaptationRepositoryItemProvider == null) {
			adaptationRepositoryItemProvider = new AdaptationRepositoryItemProvider(this);
		}

		return adaptationRepositoryItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link tools.descartes.dni.dnimm3ap.AdaptableNode} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected AdaptableNodeItemProvider adaptableNodeItemProvider;

	/**
	 * This creates an adapter for a {@link tools.descartes.dni.dnimm3ap.AdaptableNode}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createAdaptableNodeAdapter() {
		if (adaptableNodeItemProvider == null) {
			adaptableNodeItemProvider = new AdaptableNodeItemProvider(this);
		}

		return adaptableNodeItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link tools.descartes.dni.dnimm3ap.AdaptableLink} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected AdaptableLinkItemProvider adaptableLinkItemProvider;

	/**
	 * This creates an adapter for a {@link tools.descartes.dni.dnimm3ap.AdaptableLink}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createAdaptableLinkAdapter() {
		if (adaptableLinkItemProvider == null) {
			adaptableLinkItemProvider = new AdaptableLinkItemProvider(this);
		}

		return adaptableLinkItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link tools.descartes.dni.dnimm3ap.AdaptableLinkPerformance} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected AdaptableLinkPerformanceItemProvider adaptableLinkPerformanceItemProvider;

	/**
	 * This creates an adapter for a {@link tools.descartes.dni.dnimm3ap.AdaptableLinkPerformance}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createAdaptableLinkPerformanceAdapter() {
		if (adaptableLinkPerformanceItemProvider == null) {
			adaptableLinkPerformanceItemProvider = new AdaptableLinkPerformanceItemProvider(this);
		}

		return adaptableLinkPerformanceItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link tools.descartes.dni.dnimm3ap.AdaptableEndPerformance} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected AdaptableEndPerformanceItemProvider adaptableEndPerformanceItemProvider;

	/**
	 * This creates an adapter for a {@link tools.descartes.dni.dnimm3ap.AdaptableEndPerformance}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createAdaptableEndPerformanceAdapter() {
		if (adaptableEndPerformanceItemProvider == null) {
			adaptableEndPerformanceItemProvider = new AdaptableEndPerformanceItemProvider(this);
		}

		return adaptableEndPerformanceItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link tools.descartes.dni.dnimm3ap.AdaptableIntermediatePerformance} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected AdaptableIntermediatePerformanceItemProvider adaptableIntermediatePerformanceItemProvider;

	/**
	 * This creates an adapter for a {@link tools.descartes.dni.dnimm3ap.AdaptableIntermediatePerformance}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createAdaptableIntermediatePerformanceAdapter() {
		if (adaptableIntermediatePerformanceItemProvider == null) {
			adaptableIntermediatePerformanceItemProvider = new AdaptableIntermediatePerformanceItemProvider(this);
		}

		return adaptableIntermediatePerformanceItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link tools.descartes.dni.dnimm3ap.AdaptableSdnNodePerformance} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected AdaptableSdnNodePerformanceItemProvider adaptableSdnNodePerformanceItemProvider;

	/**
	 * This creates an adapter for a {@link tools.descartes.dni.dnimm3ap.AdaptableSdnNodePerformance}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createAdaptableSdnNodePerformanceAdapter() {
		if (adaptableSdnNodePerformanceItemProvider == null) {
			adaptableSdnNodePerformanceItemProvider = new AdaptableSdnNodePerformanceItemProvider(this);
		}

		return adaptableSdnNodePerformanceItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link tools.descartes.dni.dnimm3ap.AdaptableNetworkInterface} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected AdaptableNetworkInterfaceItemProvider adaptableNetworkInterfaceItemProvider;

	/**
	 * This creates an adapter for a {@link tools.descartes.dni.dnimm3ap.AdaptableNetworkInterface}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createAdaptableNetworkInterfaceAdapter() {
		if (adaptableNetworkInterfaceItemProvider == null) {
			adaptableNetworkInterfaceItemProvider = new AdaptableNetworkInterfaceItemProvider(this);
		}

		return adaptableNetworkInterfaceItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link tools.descartes.dni.dnimm3ap.AdaptableNetworkInterfacePerformance} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected AdaptableNetworkInterfacePerformanceItemProvider adaptableNetworkInterfacePerformanceItemProvider;

	/**
	 * This creates an adapter for a {@link tools.descartes.dni.dnimm3ap.AdaptableNetworkInterfacePerformance}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createAdaptableNetworkInterfacePerformanceAdapter() {
		if (adaptableNetworkInterfacePerformanceItemProvider == null) {
			adaptableNetworkInterfacePerformanceItemProvider = new AdaptableNetworkInterfacePerformanceItemProvider(this);
		}

		return adaptableNetworkInterfacePerformanceItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link tools.descartes.dni.dnimm3ap.AdaptationGroups} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected AdaptationGroupsItemProvider adaptationGroupsItemProvider;

	/**
	 * This creates an adapter for a {@link tools.descartes.dni.dnimm3ap.AdaptationGroups}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createAdaptationGroupsAdapter() {
		if (adaptationGroupsItemProvider == null) {
			adaptationGroupsItemProvider = new AdaptationGroupsItemProvider(this);
		}

		return adaptationGroupsItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link tools.descartes.dni.dnimm3ap.NodeAdaptationGroup} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected NodeAdaptationGroupItemProvider nodeAdaptationGroupItemProvider;

	/**
	 * This creates an adapter for a {@link tools.descartes.dni.dnimm3ap.NodeAdaptationGroup}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createNodeAdaptationGroupAdapter() {
		if (nodeAdaptationGroupItemProvider == null) {
			nodeAdaptationGroupItemProvider = new NodeAdaptationGroupItemProvider(this);
		}

		return nodeAdaptationGroupItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link tools.descartes.dni.dnimm3ap.LinkAdaptationGroup} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected LinkAdaptationGroupItemProvider linkAdaptationGroupItemProvider;

	/**
	 * This creates an adapter for a {@link tools.descartes.dni.dnimm3ap.LinkAdaptationGroup}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createLinkAdaptationGroupAdapter() {
		if (linkAdaptationGroupItemProvider == null) {
			linkAdaptationGroupItemProvider = new LinkAdaptationGroupItemProvider(this);
		}

		return linkAdaptationGroupItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link tools.descartes.dni.dnimm3ap.AlternativeDependencySet} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected AlternativeDependencySetItemProvider alternativeDependencySetItemProvider;

	/**
	 * This creates an adapter for a {@link tools.descartes.dni.dnimm3ap.AlternativeDependencySet}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createAlternativeDependencySetAdapter() {
		if (alternativeDependencySetItemProvider == null) {
			alternativeDependencySetItemProvider = new AlternativeDependencySetItemProvider(this);
		}

		return alternativeDependencySetItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link tools.descartes.dni.dnimm3ap.AdaptableDependency} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected AdaptableDependencyItemProvider adaptableDependencyItemProvider;

	/**
	 * This creates an adapter for a {@link tools.descartes.dni.dnimm3ap.AdaptableDependency}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createAdaptableDependencyAdapter() {
		if (adaptableDependencyItemProvider == null) {
			adaptableDependencyItemProvider = new AdaptableDependencyItemProvider(this);
		}

		return adaptableDependencyItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link tools.descartes.dni.dnimm3ap.AlternativeVariableSet} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected AlternativeVariableSetItemProvider alternativeVariableSetItemProvider;

	/**
	 * This creates an adapter for a {@link tools.descartes.dni.dnimm3ap.AlternativeVariableSet}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createAlternativeVariableSetAdapter() {
		if (alternativeVariableSetItemProvider == null) {
			alternativeVariableSetItemProvider = new AlternativeVariableSetItemProvider(this);
		}

		return alternativeVariableSetItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link tools.descartes.dni.dnimm3ap.AdaptableVariable} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected AdaptableVariableItemProvider adaptableVariableItemProvider;

	/**
	 * This creates an adapter for a {@link tools.descartes.dni.dnimm3ap.AdaptableVariable}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createAdaptableVariableAdapter() {
		if (adaptableVariableItemProvider == null) {
			adaptableVariableItemProvider = new AdaptableVariableItemProvider(this);
		}

		return adaptableVariableItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link tools.descartes.dni.dnimm3ap.Investment} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected InvestmentItemProvider investmentItemProvider;

	/**
	 * This creates an adapter for a {@link tools.descartes.dni.dnimm3ap.Investment}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createInvestmentAdapter() {
		if (investmentItemProvider == null) {
			investmentItemProvider = new InvestmentItemProvider(this);
		}

		return investmentItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link tools.descartes.dni.dnimm3ap.HandlingTime} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected HandlingTimeItemProvider handlingTimeItemProvider;

	/**
	 * This creates an adapter for a {@link tools.descartes.dni.dnimm3ap.HandlingTime}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createHandlingTimeAdapter() {
		if (handlingTimeItemProvider == null) {
			handlingTimeItemProvider = new HandlingTimeItemProvider(this);
		}

		return handlingTimeItemProvider;
	}

	/**
	 * This keeps track of the one adapter used for all {@link tools.descartes.dni.dnimm3ap.FixedCostFunction} instances.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	protected FixedCostFunctionItemProvider fixedCostFunctionItemProvider;

	/**
	 * This creates an adapter for a {@link tools.descartes.dni.dnimm3ap.FixedCostFunction}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter createFixedCostFunctionAdapter() {
		if (fixedCostFunctionItemProvider == null) {
			fixedCostFunctionItemProvider = new FixedCostFunctionItemProvider(this);
		}

		return fixedCostFunctionItemProvider;
	}

	/**
	 * This returns the root adapter factory that contains this factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public ComposeableAdapterFactory getRootAdapterFactory() {
		return parentAdapterFactory == null ? this : parentAdapterFactory.getRootAdapterFactory();
	}

	/**
	 * This sets the composed adapter factory that contains this factory.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void setParentAdapterFactory(ComposedAdapterFactory parentAdapterFactory) {
		this.parentAdapterFactory = parentAdapterFactory;
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public boolean isFactoryForType(Object type) {
		return supportedTypes.contains(type) || super.isFactoryForType(type);
	}

	/**
	 * This implementation substitutes the factory itself as the key for the adapter.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Adapter adapt(Notifier notifier, Object type) {
		return super.adapt(notifier, this);
	}

	/**
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	@Override
	public Object adapt(Object object, Object type) {
		if (isFactoryForType(type)) {
			Object adapter = super.adapt(object, type);
			if (!(type instanceof Class<?>) || (((Class<?>)type).isInstance(adapter))) {
				return adapter;
			}
		}

		return null;
	}

	/**
	 * This adds a listener.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void addListener(INotifyChangedListener notifyChangedListener) {
		changeNotifier.addListener(notifyChangedListener);
	}

	/**
	 * This removes a listener.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void removeListener(INotifyChangedListener notifyChangedListener) {
		changeNotifier.removeListener(notifyChangedListener);
	}

	/**
	 * This delegates to {@link #changeNotifier} and to {@link #parentAdapterFactory}.
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void fireNotifyChanged(Notification notification) {
		changeNotifier.fireNotifyChanged(notification);

		if (parentAdapterFactory != null) {
			parentAdapterFactory.fireNotifyChanged(notification);
		}
	}

	/**
	 * This disposes all of the item providers created by this factory. 
	 * <!-- begin-user-doc -->
	 * <!-- end-user-doc -->
	 * @generated
	 */
	public void dispose() {
		if (adaptationPointsItemProvider != null) adaptationPointsItemProvider.dispose();
		if (adaptationRepositoryItemProvider != null) adaptationRepositoryItemProvider.dispose();
		if (adaptableNodeItemProvider != null) adaptableNodeItemProvider.dispose();
		if (adaptableLinkItemProvider != null) adaptableLinkItemProvider.dispose();
		if (adaptableLinkPerformanceItemProvider != null) adaptableLinkPerformanceItemProvider.dispose();
		if (adaptableEndPerformanceItemProvider != null) adaptableEndPerformanceItemProvider.dispose();
		if (adaptableIntermediatePerformanceItemProvider != null) adaptableIntermediatePerformanceItemProvider.dispose();
		if (adaptableSdnNodePerformanceItemProvider != null) adaptableSdnNodePerformanceItemProvider.dispose();
		if (adaptableNetworkInterfaceItemProvider != null) adaptableNetworkInterfaceItemProvider.dispose();
		if (adaptableNetworkInterfacePerformanceItemProvider != null) adaptableNetworkInterfacePerformanceItemProvider.dispose();
		if (adaptationGroupsItemProvider != null) adaptationGroupsItemProvider.dispose();
		if (nodeAdaptationGroupItemProvider != null) nodeAdaptationGroupItemProvider.dispose();
		if (linkAdaptationGroupItemProvider != null) linkAdaptationGroupItemProvider.dispose();
		if (alternativeDependencySetItemProvider != null) alternativeDependencySetItemProvider.dispose();
		if (adaptableDependencyItemProvider != null) adaptableDependencyItemProvider.dispose();
		if (alternativeVariableSetItemProvider != null) alternativeVariableSetItemProvider.dispose();
		if (adaptableVariableItemProvider != null) adaptableVariableItemProvider.dispose();
		if (investmentItemProvider != null) investmentItemProvider.dispose();
		if (handlingTimeItemProvider != null) handlingTimeItemProvider.dispose();
		if (fixedCostFunctionItemProvider != null) fixedCostFunctionItemProvider.dispose();
	}

}
